/*********************** VESA Standard 1.0 Library **************************/
#include <dos.h>
// Obecne definice
#define VESA_FN 0x4F
#define VIDEO_INT 0x10
			   // S void ptr !!!!!!
//Pro Fn 2			2VESALIB.LIB - SMALL MODEL
#define M_INITIALIZE 0x8000  // 8VESALIB.LIB - COMPACT MODEL
// Pro Fn 4
#define HWARE 1
#define BVARS  2
#define DAC_R  4
#define SSVGA  8
//VESA funkce
#define VESA_INFO 0
#define VESA_MODE_INFO 1
#define VESA_SET_MODE 2
#define VESA_CURRENT_MODE_INFO 3
#define VESA_SR_STATUS 4
#define VESA_SAVE_MEM 0 // Podfunkce SAVE/REFRESH zjisti potrebnou pamet
#define VESA_SAVE_STATUS_SVGA 1 //Podfunkce SAVE
#define VESA_REFRESH_STATUS_SVGA 2 //Podfunkce REFRESH
#define VESA_WINDOW 5
#define VESA_SEL_WINDOW 0
#define VESA_RET_WINDOW 1

typedef unsigned char byte;
typedef unsigned int word;
union REGS registry;
struct SREGS sregistry;

int VESA_CALL(byte FUNC)
    { registry.h.ah=VESA_FN;
      registry.h.al=FUNC;
      return(int86x(VIDEO_INT,&registry,&registry,&sregistry));
     };

// Fn 0
int get_vesa_info(void far *vesa_info_ptr)
    { registry.x.di=FP_OFF(vesa_info_ptr);
      sregistry.es=FP_SEG(vesa_info_ptr);
      return(VESA_CALL(VESA_INFO));
    };

// Fn 1
int get_mode_info(word mode,void far *vesa_mode_ptr)
    { registry.x.cx=mode;
      registry.x.di=FP_OFF(vesa_mode_ptr);
      sregistry.es=FP_SEG(vesa_mode_ptr);
      return(VESA_CALL(VESA_MODE_INFO));
    };

// Fn 2
int set_vesa_mode(word mode,byte init)
    { registry.x.bx=mode;
      if (init) registry.x.bx |= M_INITIALIZE;
      return(VESA_CALL(VESA_SET_MODE));
    };

// Fn 3
int get_current_mode(word far *curr_mode)
    { int pomocna=VESA_CALL(VESA_CURRENT_MODE_INFO);
       *curr_mode=registry.x.bx;
       return(pomocna);
     };

// Fn 4  subFn 0
int get_save_size(word far *blocks,byte hw,byte bios_vars,byte dac,byte svga_status)
    { registry.x.cx=0;
      if (hw) registry.x.cx  |= HWARE;
      if (bios_vars) registry.x.cx |= BVARS;
      if (dac) registry.x.cx |= DAC_R;
      if (svga_status) registry.x.cx |= SSVGA;
      registry.h.dl=VESA_SAVE_MEM;
      int pomocna=VESA_CALL(VESA_SR_STATUS);
      *blocks=registry.x.bx;// * 64byte
      return(pomocna);
    };

// Fn 4  subFn 1
int save_svga_status(void far *_svgabuf,byte hw,byte bios_vars,byte dac,byte svga_status)
    { registry.x.cx=0;
      if (hw) registry.x.cx |= HWARE;
      if (bios_vars) registry.x.cx |= BVARS;
      if (dac) registry.x.cx |= DAC_R;
      if (svga_status) registry.x.cx |= SSVGA;
      registry.x.bx=FP_OFF(_svgabuf);
      sregistry.es=FP_SEG(_svgabuf);
      registry.h.dl=VESA_SAVE_STATUS_SVGA;
      return(VESA_CALL(VESA_SR_STATUS));
    };

// Fn 4  subFn 2
int refresh_svga_status(void far *_svgabuf,byte hw,byte bios_vars,byte dac,byte svga_status)
    { registry.x.cx=0;
      if (hw) registry.x.cx |= HWARE;
      if (bios_vars) registry.x.cx |= BVARS;
      if (dac) registry.x.cx |= DAC_R;
      if (svga_status) registry.x.cx |= SSVGA;
      registry.x.bx=FP_OFF(_svgabuf);
      sregistry.es=FP_SEG(_svgabuf);
      registry.h.dl=VESA_REFRESH_STATUS_SVGA;
      return(VESA_CALL(VESA_SR_STATUS));
    };

// Fn 5  subFn 0
int select_acces_window(byte no_win,word pos_win)
    { registry.h.bl=no_win;
      registry.h.bh=VESA_SEL_WINDOW;
      registry.x.dx=pos_win;
      return(VESA_CALL(VESA_WINDOW));
    };

// Fn 5  subFn 1
int return_acces_window(byte no_win,word far *pos_win)
    { registry.h.bl=no_win;
      registry.h.bh=VESA_RET_WINDOW;
      int pomocna=VESA_CALL(VESA_WINDOW);
      *pos_win=registry.x.dx;
      return(pomocna);
    };

// THAT's ALL FOLKS !