/*********************** VESA Standard 1.0 Library **************************/
// Obecne definice		Header File
#define VESA_FN 0x4F
#define VIDEO_INT 0x10
//VESA funkce		      U funkci parametry  VOID PTR !!!
#define VESA_INFO 0	 // 2VESALIB.LIB - SMALL
#define VESA_MODE_INFO 1 // 8VESALIB.LIB - COMPACT
#define VESA_SET_MODE 2
#define VESA_CURRENT_MODE_INFO 3
#define VESA_SR_STATUS 4
#define VESA_SAVE_MEM 0 // Podfunkce SAVE/REFRESH zjisti potrebnou pamet
#define VESA_SAVE_STATUS_SVGA 1 //Podfunkce SAVE
#define VESA_REFRESH_STATUS_SVGA 2 //Podfunkce REFRESH
#define VESA_WINDOW 5
#define VESA_SEL_WINDOW 0
#define VESA_RET_WINDOW 1

typedef unsigned int word;
typedef unsigned char byte;

//Pro funkci 0
struct VESA_INFO_BLOCK {
   char VESA_SIGNATURE[4];
   int VESA_VERSION;
   char far *SVGA_PRODUCENT;
   byte VLASTNOSTI_SVGA[4];
   word far *LIST_OF_MODES;
 };
#define END_LIST 0xffff


// Pro funkci 1
struct MODE_INFO_BLOCK
 { //Povinne
    struct {byte HW_SUPPORTS_THIS_MODE:1,NEPOVINNE:1;
	    byte BIOS_OUT:1,COLOR:1,GRAPHIC_MODE:1;
	   } MODE_FLAG;
    struct {byte AWINDOW_ACCES_ENABLED:1;
	    byte AREAD_ENABLED:1,AWRITE_ENABLED:1;
	    word :5;
	    byte BWINDOW_ACCES_ENABLED:1;
	    byte BREAD_ENABLED:1,BWRITE_ENABLED:1;
	   } WIN_ATR;
   word WIN_GRAN,WIN_SIZE,WINA_SEG,WINB_SEG;
   void far (*WINFUNC)(); //POZOR!!!
   //void far *WINFUNC;
   word BYTES_IN_SCL;
   //Nepovinne
   word XRES,YRES;
   byte XCHRSIZE,YCHRSIZE,BIT_PLANES_NUM,BITS_PER_PIXEL,BANKS_NUM;
   byte MEMORY_MODEL;
   byte BANK_SIZE;
  };

//Zkontrolovat spravnost far pointeru !!!!
int  get_vesa_info(void far *);
int  get_mode_info(word,void far *);
int  set_vesa_mode(word,byte);
int  get_current_mode(word far *);
int  get_save_size(word far *,byte,byte,byte,byte);
int  save_svga_status(void far *,byte,byte,byte,byte);
int  refresh_svga_status(void far *,byte,byte,byte,byte);
int  select_acces_window(byte,word);
int  return_acces_window(byte,word far *);