// Something running on the screen (to cursor)



#include <windows.h>





LRESULT CALLBACK _export ObsluhaOkna(HWND,UINT,WPARAM,LPARAM);

LPCSTR ClassName = "Bird";
HINSTANCE hInstance;

BOOL RegClass(void)
{
  WNDCLASS wc;

  wc.style = NULL;
  wc.lpfnWndProc = ObsluhaOkna;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance	= hInstance;
  wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL,IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName = NULL;
  wc.lpszClassName = ClassName;

  return(RegisterClass(&wc));
}


#pragma argsused
int PASCAL WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR CmdLine,int Show)
{
  hInstance = hInst;

  if(RegClass())
  {
    HWND hwnd = CreateWindow(ClassName,ClassName,
		WS_OVERLAPPEDWINDOW |  WS_SYSMENU,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,NULL,hInst,NULL);
    #define IDM_SETTINGS 120
    #define IDM_ABOUT	 121
    HMENU hSysMenu = GetSystemMenu(hwnd,FALSE);
    UINT mId;
    ModifyMenu(hSysMenu,
	       mId = GetMenuItemID(hSysMenu,0),
	       MF_STRING,
	       mId,
	       "About .."
	       );

    InsertMenu(hSysMenu,1,MF_BYPOSITION,IDM_SETTINGS,"Settings");
    InsertMenu(hSysMenu,2,MF_BYPOSITION | MF_SEPARATOR,0,NULL);
    ShowWindow(hwnd,SW_SHOWMINIMIZED);
    UpdateWindow(hwnd);

    MSG msg;
    while(GetMessage(&msg,NULL,0,0))
    {
     TranslateMessage(&msg);
     DispatchMessage(&msg);
    }

    return msg.wParam;
  }
  else return FALSE;
}   // WinMain


#pragma argsused
LRESULT CALLBACK _export ObsluhaOkna(HWND hwnd,UINT Message,WPARAM wParam,LPARAM lParam)
{
  #define PICTURES 8 // 4
  #define SCREEN 0
  #define Postup 5
  static HDC hLastScreenDC,hMemDC;
  static HBITMAP hCBitmap,hPrevObject,hBirds,hBirdsM;//hLBitmaps[PICTURES];
  static int Xcoord,Ycoord,
	     Width=40,Height=32,
	     Speed=100,
	     CurrentPic=0;


  switch(Message)
  {
    case WM_CREATE : hBirds = LoadBitmap(hInstance,
				   MAKEINTRESOURCE(1));
		     hBirdsM = LoadBitmap(hInstance,
				   MAKEINTRESOURCE(2));

		     BITMAP bmInfo;
		     GetObject(hBirds,sizeof(BITMAP),&bmInfo);
		     Height = bmInfo.bmHeight;
		     Width  = bmInfo.bmWidth / PICTURES;

		     hLastScreenDC = GetDC(SCREEN);
		     hMemDC = CreateCompatibleDC(SCREEN);
		     hCBitmap = CreateCompatibleBitmap(hLastScreenDC,
					       bmInfo.bmWidth,Height);
		     hPrevObject = SelectObject(hMemDC,hCBitmap);

		     //RECT WRect;
		     //GetWindowRect(hwnd,&WRect);
		     Xcoord=0;//WRect.right;
		     Ycoord=0;//WRect.top;

		     // save screen fragment
		     BitBlt(hMemDC,0,0,
			     Width,Height,
			     hLastScreenDC,
			     Xcoord,Ycoord,SRCCOPY);

		     HBITMAP hScreenFragment =
			  SelectObject(hMemDC,hBirdsM);

		     // draw 1st picture
		     BitBlt(hLastScreenDC,Xcoord,Ycoord,
			     Width,Height,
			     hMemDC,
			     0,0,SRCAND);

		     SelectObject(hMemDC,hBirds);
		     BitBlt(hLastScreenDC,Xcoord,Ycoord,
			     Width,Height,
			     hMemDC,
			     0,0,SRCPAINT);

		     SelectObject(hMemDC,hScreenFragment);

		     SetTimer(hwnd,1,Speed,NULL);
		     break;

    case WM_DESTROY : KillTimer(hwnd,1);
		      // obnov posledni fragment
		      BitBlt(hLastScreenDC,Xcoord,Ycoord,
			     Width,Height,
			     hMemDC,0,0,SRCCOPY);

		      SelectObject(hMemDC,hPrevObject);
		      InvalidateRect(SCREEN,NULL,FALSE);
		      DeleteDC(hMemDC);
		      ReleaseDC(SCREEN,hLastScreenDC);

		      DeleteObject(hCBitmap);
		      DeleteObject(hBirds);
		      DeleteObject(hBirdsM);

		      PostQuitMessage(0);
		      UnregisterClass(ClassName,hInstance);
		      break;

    case WM_QUERYOPEN :MessageBox(hwnd,"Blbost\nod Eliho","About",MB_OK);
		       break;

    case WM_TIMER : 
		    POINT Point;
		    GetCursorPos(&Point);
		    Point.x -= Width >> 1;
		    Point.y -= Height >> 1;
		    
		    BOOL Xplus = Xcoord > Point.x+Postup+1;
		    BOOL Xminus= Xcoord < Point.x-Postup-1;
		    BOOL Yplus = Ycoord > Point.y+Postup+1;
		    BOOL Yminus= Ycoord < Point.y-Postup-1;
		    BOOL Uprostred = !Xplus && !Xminus &&
				     !Yplus && !Yminus;
		    if(!Uprostred)
		    {

		    // obnov fragment na poslednim ScreenDC
		    BitBlt(hLastScreenDC,Xcoord,Ycoord,Width,Height,
			   hMemDC,0,0,SRCCOPY);
		    ReleaseDC(SCREEN,hLastScreenDC);

		    // pro jistotu repaint desktop
		    RECT ScrRect;
		    HWND hDesk;
		    SetRect(&ScrRect,Xcoord,Ycoord,Width+Xcoord,Height+Ycoord);
		    InvalidateRect(hDesk=GetDesktopWindow(),&ScrRect,TRUE);
		    UpdateWindow(hDesk);

		    Xcoord -= Postup * Xplus		// Width
			     - Postup * Xminus ;	  // Width
		    Ycoord -=Postup * Yplus	       // Height
			     - Postup * Yminus ;
		    /*
		    if(!Uprostred)
		    {
		     OldX=Xcoord;
		     OldY=Ycoord;
		    }
		    */


		    if(CurrentPic >=PICTURES) CurrentPic=0;



		    /*
		    Point.x=OldX+Width >> 1;
		    Point.y=OldY+Height >> 1;
		    InvalidateRect(hDesk=WindowFromPoint(Point),&ScrRect,TRUE);
		    UpdateWindow(hDesk);
		    */

		    // novy screen
		    HDC hScreenDC = hLastScreenDC = GetDC(SCREEN);

		    // save screen fragment
		    BitBlt(hMemDC,0,0,Width,Height,
			   hScreenDC,Xcoord,Ycoord,SRCCOPY);

		    //if(!Uprostred)
		    //{
		      hScreenFragment = SelectObject(hMemDC,
					hBirdsM);
		      // draw picture
		      BitBlt(hScreenDC,Xcoord,Ycoord,Width,
			     Height,
			     hMemDC,Width*CurrentPic++,0,SRCAND);

		      SelectObject(hMemDC,hBirds);

		      BitBlt(hScreenDC,Xcoord,Ycoord,Width,
			     Height,
			     hMemDC,Width*CurrentPic++,0,SRCPAINT);

		      SelectObject(hMemDC,hScreenFragment);
		     } // if
		    break;



    default : return(DefWindowProc(hwnd,Message,wParam,lParam));

  } // switch

 return NULL;
}  // ObsluhaOkna