// Something running on the screen (to cursor)

#define STRICT

#include <windows.h>





LRESULT CALLBACK _export ObsluhaOkna(HWND,UINT,WPARAM,LPARAM);

LPCSTR ClassName = "Bird";
extern HINSTANCE _hInstance;

BOOL RegClass(void)
{
  WNDCLASS wc;

  wc.style = NULL;
  wc.lpfnWndProc = ObsluhaOkna;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance	= _hInstance;
  wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL,IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName = NULL;
  wc.lpszClassName = ClassName;

  return(RegisterClass(&wc));
}


#pragma argsused
int PASCAL WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR CmdLine,int Show)
{
  if(RegClass())
  {
    HWND hwnd = CreateWindow(ClassName,ClassName,
		WS_OVERLAPPEDWINDOW |  WS_SYSMENU,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,NULL,hInst,NULL);
    #define IDM_SETTINGS 120
    #define IDM_ABOUT	 121
    HMENU hSysMenu = GetSystemMenu(hwnd,FALSE);
    UINT mId;
    ModifyMenu(hSysMenu,
	       mId = GetMenuItemID(hSysMenu,0),
	       MF_STRING,
	       mId,
	       "About .."
	       );

    InsertMenu(hSysMenu,1,MF_BYPOSITION,IDM_SETTINGS,"Settings");
    InsertMenu(hSysMenu,2,MF_BYPOSITION | MF_SEPARATOR,0,NULL);
    ShowWindow(hwnd,SW_SHOWMINIMIZED);
    UpdateWindow(hwnd);

    MSG msg;
    while(GetMessage(&msg,NULL,0,0))
    {
     TranslateMessage(&msg);
     DispatchMessage(&msg);
    }

    return msg.wParam;
  }
  else return FALSE;
}   // WinMain


#pragma argsused
LRESULT CALLBACK _export ObsluhaOkna(HWND hwnd,UINT Message,WPARAM wParam,LPARAM lParam)
{
  #define PICTURES 4
  #define SCREEN 0
  static HDC hMemDC;
  static HBITMAP hCBitmap,hPrevObject,hBirds,hBirdsM;//hLBitmaps[PICTURES];
  static int Xcoord,Ycoord,OldX,OldY,
	     Width=40,Height=32,
	     Speed=200,
	     CurrentPic=0;


  switch(Message)
  {
    case WM_CREATE : hBirds = LoadBitmap(_hInstance,
				   MAKEINTRESOURCE(1));
		     hBirdsM = LoadBitmap(_hInstance,
				   MAKEINTRESOURCE(2));

		     BITMAP bmInfo;
		     GetObject(hBirds,sizeof(BITMAP),&bmInfo);
		     Height = bmInfo.bmHeight;
		     Width  = bmInfo.bmWidth / PICTURES;

		     HDC hScreenDC = GetDC(SCREEN);
		     hMemDC = CreateCompatibleDC(SCREEN);
		     hCBitmap = CreateCompatibleBitmap(hScreenDC,
					       bmInfo.bmWidth,Height);
		     hPrevObject = SelectObject(hMemDC,hCBitmap);
		     ReleaseDC(SCREEN,hScreenDC);
		     //RECT WRect;
		     //GetWindowRect(hwnd,&WRect);

		     Xcoord=0;//WRect.right;
		     Ycoord=0;//WRect.top;
		     /*
		     // save screen fragment
		     BitBlt(hMemDC,0,0,
			     Width,Height,
			     hLastScreenDC,
			     Xcoord,Ycoord,SRCCOPY);

		     HBITMAP hScreenFragment =
			  SelectObject(hMemDC,hBirdsM);

		     // draw 1st picture
		     BitBlt(hLastScreenDC,Xcoord,Ycoord,
			     Width,Height,
			     hMemDC,
			     0,0,SRCAND);

		     SelectObject(hMemDC,hBirds);
		     BitBlt(hLastScreenDC,Xcoord,Ycoord,
			     Width,Height,
			     hMemDC,
			     0,0,SRCPAINT);

		     SelectObject(hMemDC,hScreenFragment);
		      */
		     SetTimer(hwnd,1,Speed,NULL);
		     break;

    case WM_DESTROY : KillTimer(hwnd,1);
		      // obnov posledni fragment
		      /*
		      BitBlt(hLastScreenDC,Xcoord,Ycoord,
			     Width,Height,
			     hMemDC,0,0,SRCCOPY);
		      */
		      SelectObject(hMemDC,hPrevObject);
		      DeleteDC(hMemDC);
		      //ReleaseDC(SCREEN,hLastScreenDC);

		      DeleteObject(hCBitmap);
		      DeleteObject(hBirds);
		      DeleteObject(hBirdsM);

		      PostQuitMessage(0);
		      UnregisterClass(ClassName,hInstance);
		      break;

    case WM_QUERYOPEN :MessageBox(hwnd,"Blbost\nod Eliho","About",MB_OK);
		       break;

    case WM_TIMER : POINT Point;
		    GetCursorPos(&Point);
		    OldX=Xcoord;OldY=Ycoord;
		    if(Xcoord > Point.x+Width) Xcoord -=5;//Width;
		    else
		     if(Xcoord < Point.x) Xcoord +=5;//Width;

		    if(Ycoord > Point.y+Height) Ycoord -=5;//Height;
		    else
		     if(Ycoord < Point.y) Ycoord +=5;//Height;

		    if(CurrentPic >=PICTURES) CurrentPic=0;

		    // obnov fragment na poslednim ScreenDC
		    /*BitBlt(hLastScreenDC,OldX,OldY,Width,Height,
			   hMemDC,0,0,SRCCOPY);

		    ReleaseDC(SCREEN,hLastScreenDC);
		    */
		    // novy screen
		     hScreenDC = GetDC(SCREEN);
		    //SelectObject(hMemDC,hCBitmap);
		    // save screen fragment
		    BitBlt(hMemDC,0,0,Width,Height,
			   hScreenDC,Xcoord,Ycoord,SRCCOPY);

		    HBITMAP hScreenFragment = SelectObject(hMemDC,
				      hBirdsM);

		    // draw picture
		    BitBlt(hScreenDC,Xcoord,Ycoord,Width,
			   Height,
			   hMemDC,Width*CurrentPic++,0,SRCAND);

		    SelectObject(hMemDC,hBirds);

		    BitBlt(hScreenDC,Xcoord,Ycoord,Width,
			   Height,
			   hMemDC,Width*CurrentPic++,0,SRCPAINT);
		    for(long i=0;i<200000;i++);
		    SelectObject(hMemDC,hScreenFragment);
		    BitBlt(hScreenDC,Xcoord,Ycoord,Width,Height,
			   hMemDC,0,0,SRCCOPY);

		    ReleaseDC(SCREEN,hScreenDC);

		    SelectObject(hMemDC,hCBitmap);
		    break;



    default : return(DefWindowProc(hwnd,Message,wParam,lParam));

  } // switch

 return NULL;
}  // ObsluhaOkna