#include "vesa100.h"

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

#define CRTC 0x3D4

#define H_TOTAL 0
#define H_DISP_ENABLE_END 1
#define H_BLANK_START 2
#define H_BLANK_END 3
#define H_RETR_START 4
#define H_RETR_END 5
#define V_TOTAL 6
#define CRTC_OVERFLOW 7
#define PRESET_ROW_SCAN 8
#define MAX_SCAN_LINE 9
#define V_RETR_START 0x10
#define V_RETR_END 0x11
#define V_DISP_ENABLE_END 0x12
#define V_BLANK_START 0x15
#define V_BLANK_END 0x16
#define CRT_MODE_CNTL 0x17

// Atributovy kontroler
#define ATTRIBUTE 0x3c0
#define OVERSCAN_COLOR 0x11
#define H_PEL_PAN 0x13

// Keyboard
#define ESC   0x1b
#define Enter 0xd
#define UP    0x48
#define DOWN  0x50
#define LEFT  0x4b
#define RIGHT 0x4d
#define ALT   8
#define SHIFT 3

#define VGAMEM 64
#define VGAMEMKB 1024

#define ReadCRTReg(REG) (outp(CRTC,(REG)),inp(CRTC+1))
#define WriteCRTReg(REG,VAL) ( outp(CRTC,(REG)) , outp(CRTC+1,(VAL)) )
#define ChangeCRTReg(REG,VAL) ( WriteCRTReg( (REG),ReadCRTReg(REG)+(VAL) ) )

#define ReadCRTRegVRS(VAR) ( (VAR) ? ReadCRTReg(V_RETR_START) + ((overflow & 4) << 6) + ((overflow & 0x80) << 2) : 0 )
#define ReadCRTRegVBS(VAR) ( (VAR) ? ReadCRTReg(V_BLANK_START) + ((overflow & 8) << 5) + ((maxscanline & 0x20) << 4) : 0)
#define ReadCRTRegVDEE(VAR) ( (VAR) ? ReadCRTReg(V_DISP_ENABLE_END) + ((overflow & 2) << 7) + ((overflow & 0x40) << 3) : 0)

#define ReadATRReg(REG) (outp(ATTRIBUTE,(REG)),inp(ATTRIBUTE+1))
#define WriteATRReg(REG,VAL) ( outp(ATTRIBUTE,(REG)) , outp(ATTRIBUTE+1,(VAL)) )
#define ChangeATRReg(REG,VAL) ( WriteATRReg( (REG),ReadATRReg(REG)+(VAL) ) )

/*
#define WriteCRTRegVRS(VAL)  ( WriteCRTReg(V_RETR_START,(VAL)) ,\
                               WriteCRTReg( CRTC_OVERFLOW,\
                               (ReadCRTReg(CRTC_OVERFLOW) & 0x7b) | \
                                (( (VAL) & 0x200 ) >> 2) ) ,\
                               WriteCRTReg( CRTC_OVERFLOW,\
                                (ReadCRTReg(CRTC_OVERFLOW) | \
                                (( (VAL) & 0x100 ) >> 6) ) )
//#define WriteCRTRegVBS(VAL)  ( WriteCRTReg(V_BLANK_START,(VAL)) , WriteCRTReg( MAX_SCAN_LINE, (( (VAL) & 0x200 ) >> 4) ) , WriteCRTReg( CRTC_OVERFLOW, ( ( (VAL) & 0x100 ) >> 5) ) )
//#define WriteCRTRegVDEE(VAL) ( WriteCRTReg(V_DISP_ENABLE_END,(VAL)) , WriteCRTReg( CRTC_OVERFLOW , (( (VAL) & 0x200 ) >> 3) ) , WriteCRTReg( CRTC_OVERFLOW, ( ( (VAL) & 0x100 ) >> 7) ) )
//#define ChangeCRTRegVRS(VAL) ( WriteCRTRegVRS( ReadCRTRegVRS( 1 ) + (VAL) ) )
//#define ChangeCRTRegVDEE(VAL) ( WriteCRTRegVDEE(ReadCRTRegVDEE(1)+(VAL)) )
*/
#define DeadKeyPressed(KEY) ( peekb( 0x40,0x17 ) & KEY )

byte overflow , maxscanline;


void  ChangeCRTRegSpec(byte Registr, signed char value)
{
    word hodnota  = ReadCRTReg(Registr);
    hodnota      += value;
    overflow      = ReadCRTReg(CRTC_OVERFLOW);
    maxscanline   = ReadCRTReg(MAX_SCAN_LINE);

    switch(Registr)
    {
      case V_RETR_START :
           hodnota += ((overflow & 4) << 6) + ((overflow & 0x80) << 2) ;
           WriteCRTReg(Registr,hodnota);
           WriteCRTReg( CRTC_OVERFLOW,
                      ( (overflow & 0x7b) |
                        ( (hodnota & 0x200 ) >> 2 )+
                        ( (hodnota & 0x100 ) >> 6 ) ) );
           break;

      case V_BLANK_START :
           hodnota += ((overflow & 8) << 5) + ((maxscanline & 0x20) << 4) ;
           WriteCRTReg(Registr,hodnota);
           WriteCRTReg( MAX_SCAN_LINE,
                       (maxscanline & 0xdf) | ( (hodnota & 0x200 ) >> 4 ) ) ;
           WriteCRTReg( CRTC_OVERFLOW,
                       (overflow & 0xf7) | ( (hodnota & 0x100 ) >> 5 ) ) ;
           break;

      case V_DISP_ENABLE_END :
           hodnota += ((overflow & 2) << 7) + ((overflow & 0x40) << 3) ;
           WriteCRTReg(Registr,hodnota);
           WriteCRTReg( CRTC_OVERFLOW,
                        (overflow & 0xbd) | ( (hodnota & 0x200 ) >> 3 )+
                        ( (hodnota & 0x100 ) >> 7 ) ) ;
   }
}

enum BOOL {ne,ano};
BOOL VESAsupported =ne;
struct
{
  word VESAmode;
  byte biosmode,hwsupport,graphical,bitplanes;
  word xresolution,yresolution,bitpix;
}
  SVGAmode[30];
byte CountOfVESA,CountOfModes= -1;

struct CRTReg
{
  word vdee,vblanks,vrs;
  byte hdee,hblanks,hrs,notallowed;
}
   CRTRegs[30];

void center(word);

#define Konec 0xff
#define Save 0xfe
#define NonVESA 0xfd

byte GetMenuSel(void)
{
  byte poradi = 0;
  #define HeaderLine 2
  #define OtherItems 6
  
  byte xmax=peekb(0x40,0x4a);
  byte ymax=peekb(0x40,0x84)+1;
  byte *radek=(byte *) malloc(CountOfModes+OtherItems);
  
  clrscr();
  byte firstline=(ymax-CountOfModes-6) >> 1 ;
  byte row=(xmax-30) >> 1 ;
  gotoxy(row+6,headerline);
  radek[poradi]=HeaderLine;
  printf("SVGA Corrector v 0.1");

  for(byte modd=0;modd <= CountOfModes;modd++)
  {
    char *colorstr;
    switch(SVGAmode[modd].bitpix)
    {
      case 4 : colorstr="16"; break;
      case 8 : colorstr="256";break;
      case 15: colorstr="32K";break;
      case 16: colorstr="64K";break;
      case 24: colorstr="16M";break;
      default: colorstr="not calculated";
    };
    radek[++poradi] = firstline+modd;
    gotoxy(row,radek[poradi]);
    printf("%2d. %3x  %2x %4d x %4d x %s\n",modd+1,SVGAmode[modd].VESAmode, \
           SVGAmode[modd].biosmode,SVGAmode[modd].xresolution, \
           SVGAmode[modd].yresolution,colorstr);
  } //for
    radek[++poradi]=firstline+modd+2;
    gotoxy(row,radek[++poradi]);
    printf("%2d. Non VESA modes",++modd);
    radek[++poradi]=firstline+modd+2;
    gotoxy(row,radek[++poradi]);
    printf("%2d. Save correcting values",++modd);
    radek[++poradi]=firstline+modd+2;
    gotoxy(row,radek[++poradi]);
    printf("%2d. Exit Correct",++modd);
    radek[++poradi]=firstline+modd+2;
    gotoxy(row,radek[++poradi]);
    printf("Enter your choice : ");
    
    byte selection;
    scanf("%u",&selection);
    if(selection <= CountOfModes+1) return selection-1;
    else
    {
      if(selection==CountOfModes+2) return NonVESA;
      if(selection==CountOfModes+3) return Save;
      if(selection==CountOfModes+4) return Konec;
    }
    return 0;
} // GetMenuSel

void main(void)
{
    VESA_INFO_BLOCK *VESAptr;
    if(get_VESA_info(VESAptr = (VESA_INFO_BLOCK *) malloc(0x100)) == 0x004f)
    {
       VESAsupported = ano ;
       MODE_INFO_BLOCK *MODEptr = (MODE_INFO_BLOCK *) malloc(0x100);
       word hmode;
       while( (hmode = *VESAptr->LIST_OF_MODES) != END_LIST )
       {
         if(get_mode_info(MODEptr,*VESAptr->LIST_OF_MODES++) == 0x004f)
         {
           SVGAmode[++CountOfModes].VESAmode  = hmode;
           SVGAmode[CountOfModes].hwsupport   = MODEptr->MODE_FLAG.HW_SUPPORTS_THIS_MODE;
           SVGAmode[CountOfModes].graphical   = MODEptr->MODE_FLAG.GRAPHIC_MODE;
           if(MODEptr -> MODE_FLAG.NEPOVINNE)
           {
             SVGAmode[CountOfModes].xresolution = MODEptr->XRES;
             SVGAmode[CountOfModes].yresolution = MODEptr->YRES;
             SVGAmode[CountOfModes].bitpix      = MODEptr->BITS_PER_PIXEL;
             SVGAmode[CountOfModes].bitplanes   = MODEptr->BIT_PLANES_NUM;
            }
            // else  if startup nenuluje VESAmode -> zero to all ,
          }  // if
       } // while
      CountOfVESA=CountOfModes;
    free(MODEptr);
    } // if VESA present
   // Other modes ++ CountOfModes
   // zero -> CRTRegs ; 0 znamena nemenit registry
    free(VESAptr);
    byte sel;
    while( (sel=GetMenuSel()) !=Konec)
    {
      if(sel <= CountOfModes)
        center( sel );
    }
    // save regs
} // end main

void center(word selmode)
{
    byte currmode = peekb(0x40,0x49);

    if (selmode <= CountOfVESA)
    { // if ok
      set_VESA_mode(SVGAmode[selmode].VESAmode);
      SVGAmode[selmode].biosmode = peekb(0x40,0x49);
    }
    else
    {
      _AX=SVGAmode[selmode].biosmode;
      geninterrupt(VIDEO_INT);
    }

    // Zapln screen a press ESC
   /*
    unsigned long xkraty;
    xkraty = (SVGAmode[selmode].xresolution) * SVGAmode[selmode].bitpix;
    long xykratpix =xkraty * (SVGAmode[selmode].yresolution);
    long delvga = xykratpix / VGAMEMKB /VGAMEM /8;
    long deldel =delvga / SVGAmode[selmode].bitplanes;
   */
    long i = ( SVGAmode[selmode].xresolution * SVGAmode[selmode].bitpix \
               /VGAMEMKB * SVGAmode[selmode].yresolution  \
               /VGAMEM /8  \
               /SVGAmode[selmode].bitplanes );
    byte vypln;
    switch(SVGAmode[selmode].bitpix)
    {
      case  4 : vypln = 0xff;break;
      case  8 : vypln = 0x33;break;
      case 15 : vypln = 0x33;break;
      case 16 : vypln = 0x66;break;
      case 24 : vypln = 0xff;
   }

    for(int j=0;j <= i+1;j++)
    {
       select_access_window(0,j);
       for(word count=0;count<=0xfffe;count++)
              pokeb(0xa000,count,vypln);
    };

         overflow      = ReadCRTReg(CRTC_OVERFLOW);
         maxscanline   = ReadCRTReg(MAX_SCAN_LINE);
    //byte hrsold        = ReadCRTReg(H_RETR_START);
    //word vrsold        = ReadCRTRegVRS(1);
    byte hdispenendold = ReadCRTReg(H_DISP_ENABLE_END);
    //word vdispenendold = ReadCRTRegVDEE(1);
    byte htotal        = ReadCRTReg(H_TOTAL);
    word vtotal        = ReadCRTReg(V_TOTAL) + ((overflow & 1) << 8) + ((overflow & 0x20) << 4);
    byte hblanksold    = ReadCRTReg(H_BLANK_START);
    word vblanksold    = ReadCRTRegVBS(vblanksold);

    if(hdispenendold > htotal)
       htotal = 0xff;    // dokud neznam 9 bit HTOTAL musi byt toto opatreni

    // Break register 0 - 7 protection
    WriteCRTReg(V_RETR_END,ReadCRTReg(V_RETR_END) & 0x7f);

    //byte overscan = ReadATRReg(OVERSCAN_COLOR);
    //WriteATRReg(OVERSCAN_COLOR,0x0);
    //ChangeATRReg(OVERSCAN_COLOR, 1);

    char key;

    while(  (( key = getch() ) != Enter) &&  (key != ESC) )
     if ( !key )
         switch( getch() )
         {
             case LEFT :
                  if( !DeadKeyPressed(SHIFT) )
                    ChangeCRTReg( H_RETR_START , 1 );
                  else
                  {
                    ChangeCRTReg( H_DISP_ENABLE_END , -1 );
                    byte hbs ;
                    if( ( hbs = ReadCRTReg(H_BLANK_START) ) > hblanksold )
                      WriteCRTReg( H_BLANK_START , hbs - 1 );
                   }
                  break;

             case RIGHT :
                  if( !DeadKeyPressed(SHIFT) )
                    ChangeCRTReg( H_RETR_START , -1 );
                  else
                  {
                    byte hdee ,hbs ;
                    if( (  hdee = ReadCRTReg(H_DISP_ENABLE_END) ) <  htotal  )
                    {
                       if(  hdee  >=  ( hbs = ReadCRTReg(H_BLANK_START) )  )
                         WriteCRTReg( H_BLANK_START , hbs + 1 );
                       WriteCRTReg( H_DISP_ENABLE_END , hdee + 1 );
                    }; // 1st if
                  }
                  break;

             case DOWN :
                  if( !DeadKeyPressed(SHIFT) )
                    ChangeCRTRegSpec(V_RETR_START , -1 );
                  else
                  {
                    word vdee ;
                    if( ( vdee = ReadCRTRegVDEE(1)) < vtotal )
                    {
                       if( vdee   >=   ReadCRTRegVBS(1)  )
                         ChangeCRTRegSpec(V_BLANK_START, 1 );
                       ChangeCRTRegSpec(V_DISP_ENABLE_END, 1 );
                    } // 1st if
                  }
                  break;

             case UP :
                  if( !DeadKeyPressed(SHIFT) )
                    ChangeCRTRegSpec(V_RETR_START, 1 );
                  else
                  {
                    ChangeCRTRegSpec(V_DISP_ENABLE_END, -1 );
                    if( ReadCRTRegVBS(1) > vblanksold )
                      ChangeCRTRegSpec(V_BLANK_START, - 1 );
                  }
         };  // switch

     if(key == Enter)
     {
        CRTRegs[selmode].hrs    = ReadCRTReg( H_RETR_START ) ;
        CRTRegs[selmode].vrs    = ReadCRTRegVRS(1) ;
        CRTRegs[selmode].hdee   = ReadCRTReg( H_DISP_ENABLE_END );
        CRTRegs[selmode].vdee   = ReadCRTRegVDEE(1);
        CRTRegs[selmode].hblanks= ReadCRTReg( H_BLANK_START );
        CRTRegs[selmode].vblanks= ReadCRTRegVBS(1);
     }
     // Protection ON
     WriteCRTReg( V_RETR_END , ReadCRTReg(V_RETR_END) | 0x80 ) ;

     byte bmode  = peekb(0,0x449);

    _AX=currmode;geninterrupt(VIDEO_INT);

} // center
