#include "vesa100.h"

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <string.h>

#define CRTC 0x3D4

#define H_TOTAL 0
#define H_DISP_ENABLE_END 1
#define H_BLANK_START 2
#define H_BLANK_END 3
#define H_RETR_START 4
#define H_RETR_END 5
#define V_TOTAL 6
#define CRTC_OVERFLOW 7
#define PRESET_ROW_SCAN 8
#define MAX_SCAN_LINE 9
#define V_RETR_START 0x10
#define V_RETR_END 0x11
#define V_DISP_ENABLE_END 0x12
#define V_BLANK_START 0x15
#define V_BLANK_END 0x16
#define CRT_MODE_CNTL 0x17

// Atributovy kontroler
#define ATTRIBUTE 0x3c0
#define OVERSCAN_COLOR 0x11
#define H_PEL_PAN 0x13

// Keyboard
#define ESC   0x1b
#define Enter 0xd
#define Space 0x20
#define UP    0x48
#define DOWN  0x50
#define LEFT  0x4b
#define RIGHT 0x4d
#define ALT   8
#define SHIFT 3

#define VGAMEM 64
#define VGAMEMKB 1024

#define ReadCRTReg(REG) (outp(CRTC,(REG)),inp(CRTC+1))
#define WriteCRTReg(REG,VAL) ( outp(CRTC,(REG)) , outp(CRTC+1,(VAL)) )
#define ChangeCRTReg(REG,VAL) ( WriteCRTReg( (REG),ReadCRTReg(REG)+(VAL) ) )

#define ReadCRTRegVRS(VAR) ( (VAR) ? ReadCRTReg(V_RETR_START) + ((overflow & 4) << 6) + ((overflow & 0x80) << 2) : 0 )
#define ReadCRTRegVBS(VAR) ( (VAR) ? ReadCRTReg(V_BLANK_START) + ((overflow & 8) << 5) + ((maxscanline & 0x20) << 4) : 0)
#define ReadCRTRegVDEE(VAR) ( (VAR) ? ReadCRTReg(V_DISP_ENABLE_END) + ((overflow & 2) << 7) + ((overflow & 0x40) << 3) : 0)

#define ReadATRReg(REG) (outp(ATTRIBUTE,(REG)),inp(ATTRIBUTE+1))
#define WriteATRReg(REG,VAL) ( outp(ATTRIBUTE,(REG)) , outp(ATTRIBUTE+1,(VAL)) )
#define ChangeATRReg(REG,VAL) ( WriteATRReg( (REG),ReadATRReg(REG)+(VAL) ) )

/*
#define WriteCRTRegVRS(VAL)  ( WriteCRTReg(V_RETR_START,(VAL)) ,\
                               WriteCRTReg( CRTC_OVERFLOW,\
                               (ReadCRTReg(CRTC_OVERFLOW) & 0x7b) | \
                                (( (VAL) & 0x200 ) >> 2) ) ,\
                               WriteCRTReg( CRTC_OVERFLOW,\
                                (ReadCRTReg(CRTC_OVERFLOW) | \
                                (( (VAL) & 0x100 ) >> 6) ) )
//#define WriteCRTRegVBS(VAL)  ( WriteCRTReg(V_BLANK_START,(VAL)) , WriteCRTReg( MAX_SCAN_LINE, (( (VAL) & 0x200 ) >> 4) ) , WriteCRTReg( CRTC_OVERFLOW, ( ( (VAL) & 0x100 ) >> 5) ) )
//#define WriteCRTRegVDEE(VAL) ( WriteCRTReg(V_DISP_ENABLE_END,(VAL)) , WriteCRTReg( CRTC_OVERFLOW , (( (VAL) & 0x200 ) >> 3) ) , WriteCRTReg( CRTC_OVERFLOW, ( ( (VAL) & 0x100 ) >> 7) ) )
//#define ChangeCRTRegVRS(VAL) ( WriteCRTRegVRS( ReadCRTRegVRS( 1 ) + (VAL) ) )
//#define ChangeCRTRegVDEE(VAL) ( WriteCRTRegVDEE(ReadCRTRegVDEE(1)+(VAL)) )
*/
#define DeadKeyPressed(KEY) ( peekb( 0x40,0x17 ) & KEY )

byte overflow , maxscanline;


void  ChangeCRTRegSpec(byte Registr, signed char value)
{
    word hodnota  = ReadCRTReg(Registr);
    hodnota      += value;
    overflow      = ReadCRTReg(CRTC_OVERFLOW);
    maxscanline   = ReadCRTReg(MAX_SCAN_LINE);

    switch(Registr)
    {
      case V_RETR_START :
           hodnota += ((overflow & 4) << 6) + ((overflow & 0x80) << 2) ;
           WriteCRTReg(Registr,hodnota);
           WriteCRTReg( CRTC_OVERFLOW,
                      ( (overflow & 0x7b) |
                        ( (hodnota & 0x200 ) >> 2 )+
                        ( (hodnota & 0x100 ) >> 6 ) ) );
           break;

      case V_BLANK_START :
           hodnota += ((overflow & 8) << 5) + ((maxscanline & 0x20) << 4) ;
           WriteCRTReg(Registr,hodnota);
           WriteCRTReg( MAX_SCAN_LINE,
                       (maxscanline & 0xdf) | ( (hodnota & 0x200 ) >> 4 ) ) ;
           WriteCRTReg( CRTC_OVERFLOW,
                       (overflow & 0xf7) | ( (hodnota & 0x100 ) >> 5 ) ) ;
           break;

      case V_DISP_ENABLE_END :
           hodnota += ((overflow & 2) << 7) + ((overflow & 0x40) << 3) ;
           WriteCRTReg(Registr,hodnota);
           WriteCRTReg( CRTC_OVERFLOW,
                        (overflow & 0xbd) | ( (hodnota & 0x200 ) >> 3 )+
                        ( (hodnota & 0x100 ) >> 7 ) ) ;
   }
}

enum BOOL {ne,ano};
BOOL VESAsupported =ne;
struct
{
  word VESAmode,allowed;
  byte biosmode,hwsupport,graphical,bitplanes;
  word xresolution,yresolution,bitpix;
}
  SVGAmode[30];
byte CountOfVESA,CountOfModes= -1;

struct CRTReg
{
  word vdee,vblanks,vrs;
  byte hdee,hblanks,hrs,notallowed;
}
   CRTRegs[30];

#define HeaderLine 2
#define OtherItems 6
#define TEXTLENGHT 30

enum COMMAND { About,Show,Inform,OtherModes,Save,Konec };
struct ItemChar
  { byte x,y;
    COMMAND command;
    char *Text;
  };
ItemChar *item=(ItemChar *) malloc(CountOfModes+OtherItems);

void Center(word);
void Info(byte);
void Hilite(byte);
//void Allow(byte);

byte row,firstline,MaxItem,Showmode,NutneLinky=6,ModeTextLength=25;

void MakeMenu(void)
{
  byte poradi = 0;

  byte xmax=peekb(0x40,0x4a);
  byte ymax=peekb(0x40,0x84)+1;
  byte xpos,xpos1,xpos2,coldouble;
  if( ymax < CountOfModes + NutneLinky )
  {
     xpos1 = ((xmax >> 1) - ModeTextLength)  >> 1;
     xpos2 = (xmax >> 1) + ((xmax - ModeTextLength) >> 1);
     xpos = xpos1;
     coldouble = 1;
  }
  else
  {
     xpos = ( xmax - ModeTextLength ) >> 1;
     coldouble = 0;
  }

  // Nadpis
  sprintf(item[poradi].Text = (char *) malloc(TEXTLENGHT),\
          "SVGA Corrector v 0.1");
  item[poradi].x = (xmax - strlen(item[poradi].Text) ) >> 1;
  item[poradi].y = HeaderLine;
  item[poradi].command = About;

  for(byte modd=0 ; modd <= CountOfModes ; modd++)
  {
    char *colorstr;
    switch(SVGAmode[modd].bitpix)
    {
      case 4 : colorstr="16"; break;
      case 8 : colorstr="256";break;
      case 15: colorstr="32K";break;
      case 16: colorstr="64K";break;
      case 24: colorstr="16M";break;
      default: colorstr="???";
    };
    sprintf(item[++poradi].Text = (char *) malloc(TEXTLENGHT),\
           "%3x  %2x %4d x %4d x %s",
           SVGAmode[modd].VESAmode, \
           SVGAmode[modd].biosmode,SVGAmode[modd].xresolution, \
           SVGAmode[modd].yresolution,colorstr);

    item[poradi].x = xpos;
    item[poradi].y = HeaderLine + modd + 2;
    if( coldouble )
      if( xpos == xpos1 )
      {
        --item[poradi].y;
        xpos = xpos2;
      };
      item[poradi].command = Show;

  } //for
    if( coldouble) modd >>= 1;
    ++modd;
    sprintf(item[++poradi].Text = (char *) malloc(TEXTLENGHT),\
            "Non VESA modes");
    item[poradi].y = HeaderLine + modd + 2;
    item[poradi].x = ( xmax - strlen(item[poradi].Text) ) >> 1;
    item[poradi].command=OtherModes;

    ++modd;
    sprintf(item[++poradi].Text = (char *) malloc(TEXTLENGHT),\
            "Save correcting values");
    item[poradi].y = HeaderLine + modd + 2;
    item[poradi].x = ( xmax - strlen(item[poradi].Text) ) >> 1;
    item[poradi].command=Save;

    ++modd;
    sprintf(item[++poradi].Text = (char *) malloc(TEXTLENGHT),\
            "Exit Correct");
    item[poradi].y = HeaderLine + modd + 2;
    item[poradi].x = ( xmax - strlen(item[poradi].Text) ) >> 1;
    item[poradi].command=Konec;

    ++modd;
    MaxItem=poradi;
}

static byte LastSel=0;

COMMAND GetMenuSel(void)
{
  clrscr();
  _AH = 1;_CH=0x20;geninterrupt(VIDEO_INT); // Cursor OFF
  for(byte it=0;it<=MaxItem;++it)
  {
    gotoxy(item[it].x,item[it].y);
    cprintf("%s",item[it].Text);
  }
  Hilite(LastSel);
  char key=0;
  while( !( (key == Enter) || (key == Space) ) )
  {
    if( !(key=getch()) )
      switch( getch() )
      {
        case UP :   LastSel = LastSel == 0 ? MaxItem : LastSel-1;
                    Hilite(LastSel);
                    break;
        case DOWN : LastSel = LastSel == MaxItem ? 0 : LastSel+1;
                    Hilite(LastSel);
      }
    else
      switch( key )
      {
        case Enter : return item[LastSel].command;
        case Space : return Inform;
      }
 } // while
    return About;
} // GetMenuSel

void Hilite(byte selItem)
{
  static byte lastsel = 0; // posledni vysvicena polozka
  gotoxy(item[lastsel].x,item[lastsel].y);
  textbackground(BLACK);
  textcolor(WHITE);
  cprintf("%s",item[lastsel].Text);
  gotoxy(item[selItem].x,item[selItem].y);
  textbackground(WHITE);
  textcolor(BLACK);
  cprintf("%s",item[selItem].Text);
  textbackground(BLACK);
  textcolor(WHITE);
  lastsel=selItem;
}
/*
void Allow(byte selline)
{
    byte povolit;
    if(SVGAmode[selline].hwsupport)
       povolit = SVGAmode[selline].allowed ^ ano;
      gotoxy(row,item[selline].y);
      printf("%s",item[selline].Text);
      if(!povolit)
        printf("X");
}
*/
void main(void)
{
    VESA_INFO_BLOCK *VESAptr;
    if(get_VESA_info(VESAptr = (VESA_INFO_BLOCK *) malloc(0x100)) == 0x004f)
    {
       VESAsupported = ano ;
       MODE_INFO_BLOCK *MODEptr = (MODE_INFO_BLOCK *) malloc(0x100);
       word hmode;
       while( (hmode = *VESAptr->LIST_OF_MODES) != END_LIST )
       {
         if(get_mode_info(MODEptr,*VESAptr->LIST_OF_MODES++) == 0x004f)
         {
           SVGAmode[++CountOfModes].VESAmode  = hmode;
           SVGAmode[CountOfModes].allowed =  \
            SVGAmode[CountOfModes].hwsupport   = \
             MODEptr->MODE_FLAG.HW_SUPPORTS_THIS_MODE;
           SVGAmode[CountOfModes].graphical   = MODEptr->MODE_FLAG.GRAPHIC_MODE;
           if(MODEptr -> MODE_FLAG.NEPOVINNE)
           {
             SVGAmode[CountOfModes].xresolution = MODEptr->XRES;
             SVGAmode[CountOfModes].yresolution = MODEptr->YRES;
             SVGAmode[CountOfModes].bitpix      = MODEptr->BITS_PER_PIXEL;
             SVGAmode[CountOfModes].bitplanes   = MODEptr->BIT_PLANES_NUM;
            }
            // else  if startup nenuluje VESAmode -> zero to all ,
          }  // if
       } // while
      CountOfVESA=CountOfModes;
    free(MODEptr);
    } // if VESA present
   // Other modes ++ CountOfModes
   // zero -> CRTRegs ; 0 znamena nemenit registry
    free(VESAptr);
    MakeMenu();
    COMMAND sel;
    while( (sel=GetMenuSel()) !=Konec)
    {
      switch( sel )
      {
        case Show : Center( LastSel-1 );
                    break;
        case Inform : Info( LastSel-1 );
                    break;
        // case OtherModes :
        // case Save :
      }
    }//while
   // if !saved save regs
} // end main

void Center(word selmode)
{
    byte currmode = peekb(0x40,0x49);

    if (selmode <= CountOfVESA)
    { // if ok
      set_VESA_mode(SVGAmode[selmode].VESAmode);
      SVGAmode[selmode].biosmode = peekb(0x40,0x49);
    }
    else
    {
      _AX=SVGAmode[selmode].biosmode;
      geninterrupt(VIDEO_INT);
    }

    // Zapln screen a press ESC
   /*
    unsigned long xkraty;
    xkraty = (SVGAmode[selmode].xresolution) * SVGAmode[selmode].bitpix;
    long xykratpix =xkraty * (SVGAmode[selmode].yresolution);
    long delvga = xykratpix / VGAMEMKB /VGAMEM /8;
    long deldel =delvga / SVGAmode[selmode].bitplanes;
   */
    long i = ( SVGAmode[selmode].xresolution * SVGAmode[selmode].bitpix \
               /VGAMEMKB * SVGAmode[selmode].yresolution  \
               /VGAMEM /8  \
               /SVGAmode[selmode].bitplanes );
    byte vypln;
    switch(SVGAmode[selmode].bitpix)
    {
      case  4 : vypln = 0xff;break;
      case  8 : vypln = 0x33;break;
      case 15 : vypln = 0x33;break;
      case 16 : vypln = 0x66;break;
      case 24 : vypln = 0xff;
   }

    for(int j=0;j <= i+1;j++)
    {
       select_access_window(0,j);
       for(word count=0;count<=0xfffe;count++)
              pokeb(0xa000,count,vypln);
    };

         overflow      = ReadCRTReg(CRTC_OVERFLOW);
         maxscanline   = ReadCRTReg(MAX_SCAN_LINE);
    //byte hrsold        = ReadCRTReg(H_RETR_START);
    //word vrsold        = ReadCRTRegVRS(1);
    byte hdispenendold = ReadCRTReg(H_DISP_ENABLE_END);
    //word vdispenendold = ReadCRTRegVDEE(1);
    byte htotal        = ReadCRTReg(H_TOTAL);
    word vtotal        = ReadCRTReg(V_TOTAL) + ((overflow & 1) << 8) + ((overflow & 0x20) << 4);
    byte hblanksold    = ReadCRTReg(H_BLANK_START);
    word vblanksold    = ReadCRTRegVBS(vblanksold);

    if(hdispenendold > htotal)
       htotal = 0xff;    // dokud neznam 9 bit HTOTAL musi byt toto opatreni

    // Break register 0 - 7 protection
    WriteCRTReg(V_RETR_END,ReadCRTReg(V_RETR_END) & 0x7f);

    //byte overscan = ReadATRReg(OVERSCAN_COLOR);
    //WriteATRReg(OVERSCAN_COLOR,0x0);
    //ChangeATRReg(OVERSCAN_COLOR, 1);

    char key;

    while(  (( key = getch() ) != Enter) &&  (key != ESC) )
     if ( !key )
         switch( getch() )
         {
             case LEFT :
                  if( !DeadKeyPressed(SHIFT) )
                    ChangeCRTReg( H_RETR_START , 1 );
                  else
                  {
                    ChangeCRTReg( H_DISP_ENABLE_END , -1 );
                    byte hbs ;
                    if( ( hbs = ReadCRTReg(H_BLANK_START) ) > hblanksold )
                      WriteCRTReg( H_BLANK_START , hbs - 1 );
                   }
                  break;

             case RIGHT :
                  if( !DeadKeyPressed(SHIFT) )
                    ChangeCRTReg( H_RETR_START , -1 );
                  else
                  {
                    byte hdee ,hbs ;
                    if( (  hdee = ReadCRTReg(H_DISP_ENABLE_END) ) <  htotal  )
                    {
                       if(  hdee  >=  ( hbs = ReadCRTReg(H_BLANK_START) )  )
                         WriteCRTReg( H_BLANK_START , hbs + 1 );
                       WriteCRTReg( H_DISP_ENABLE_END , hdee + 1 );
                    }; // 1st if
                  }
                  break;

             case DOWN :
                  if( !DeadKeyPressed(SHIFT) )
                    ChangeCRTRegSpec(V_RETR_START , -1 );
                  else
                  {
                    word vdee ;
                    if( ( vdee = ReadCRTRegVDEE(1)) < vtotal )
                    {
                       if( vdee   >=   ReadCRTRegVBS(1)  )
                         ChangeCRTRegSpec(V_BLANK_START, 1 );
                       ChangeCRTRegSpec(V_DISP_ENABLE_END, 1 );
                    } // 1st if
                  }
                  break;

             case UP :
                  if( !DeadKeyPressed(SHIFT) )
                    ChangeCRTRegSpec(V_RETR_START, 1 );
                  else
                  {
                    ChangeCRTRegSpec(V_DISP_ENABLE_END, -1 );
                    if( ReadCRTRegVBS(1) > vblanksold )
                      ChangeCRTRegSpec(V_BLANK_START, - 1 );
                  }
         };  // switch

     if(key == Enter)
     {
        CRTRegs[selmode].hrs    = ReadCRTReg( H_RETR_START ) ;
        CRTRegs[selmode].vrs    = ReadCRTRegVRS(1) ;
        CRTRegs[selmode].hdee   = ReadCRTReg( H_DISP_ENABLE_END );
        CRTRegs[selmode].vdee   = ReadCRTRegVDEE(1);
        CRTRegs[selmode].hblanks= ReadCRTReg( H_BLANK_START );
        CRTRegs[selmode].vblanks= ReadCRTRegVBS(1);
     }
     // Protection ON
     WriteCRTReg( V_RETR_END , ReadCRTReg(V_RETR_END) | 0x80 ) ;

     byte bmode  = peekb(0,0x449);

    _AX=currmode;geninterrupt(VIDEO_INT);

} // center

void chyba(void)
     { printf("VESA neprtomna,nebo nepodporovana funkce.\n");};

int show_vesa_info(void)
{
    byte Vinfo[0x100];
    struct VESA_INFO_BLOCK far *vinfo = (struct VESA_INFO_BLOCK far *) Vinfo;
    if (get_VESA_info(vinfo) == 0x004f)
          { word mode,far *pompointer = vinfo -> LIST_OF_MODES;
            printf("***************************** Vseobecn informace *****************************\n");
            printf("\nSignatura VESA        : %.4s\n",vinfo -> VESA_SIGNATURE);
            printf(  "Verze     VESA        : %d.%d\n",vinfo -> VESA_VERSION/256,vinfo -> VESA_VERSION%256);
            printf(  "Vyrobce               : %Fs \n",vinfo -> SVGA_PRODUCENT);// Snad je ukoncen 0 je tam i 20h
            printf(  "Velikost video pameti : %d KB\n",vinfo ->SVGA_MEM << 6);
            printf(  "Vlastnosti SVGA       : %x %x %x %x",vinfo -> VLASTNOSTI_SVGA[0],vinfo -> VLASTNOSTI_SVGA[1],vinfo -> VLASTNOSTI_SVGA[2],vinfo -> VLASTNOSTI_SVGA[3]);
            printf("\nPodporovan rezimy    :");
            //unsigned int far *pompointer = vinfo -> LIST_OF_MODES;
            while ((mode=*vinfo -> LIST_OF_MODES++) != END_LIST)
             printf(" %x",mode);
            vinfo->LIST_OF_MODES=pompointer;
            printf("\n\n********************************************************************************");
       }
        else {chyba();return 0;};
   getch();
}


int show_mode_info(word mode)
{
     byte Minfo[0x100];
     struct MODE_INFO_BLOCK far *minfo = (struct MODE_INFO_BLOCK far *) Minfo;
     printf("*********************************** Md %x ***********************************\n",mode);
       if (get_mode_info(minfo,mode) == 0x004f)
          { printf("\nTento rezim %s podporovn tecnickym vybavenm.\n",minfo -> MODE_FLAG.HW_SUPPORTS_THIS_MODE ? "JE" : "NENI");
            printf("Voliteln informace %s poskytnuty. ",minfo -> MODE_FLAG.NEPOVINNE ? "JSOU" : "NEJSOU");
            printf("Vystupn funkce BIOSu %s podporovny.\n",minfo -> MODE_FLAG.BIOS_OUT ? "JSOU" : "NEJSOU");
            printf("Tento rezim je %s",minfo -> MODE_FLAG.COLOR ? "BAREVNY" : "MONOCHROMATICKY");
            printf(" a %s.\n",minfo -> MODE_FLAG.GRAPHIC_MODE ? "GRAFICKY" : "TEXTOVY");
            printf("Pocet bajtu v jedn rozkladov rdce = %u.\n",minfo -> BYTES_IN_SCL);
            printf("===============================================================================\n");
            printf("Granularita oken = %u KB. ",minfo -> WIN_GRAN);
            printf("Velikost oken    = %u KB.\n",minfo -> WIN_SIZE);
            printf("Ukazatel na proceduru pro nastaven viditelnch oblast obou oken = %x : %x.",FP_SEG(minfo -> WINFUNC),FP_OFF(minfo -> WINFUNC));
            printf("\nSegmentov adresa PRVNIHO okna = %x. ",minfo -> WINA_SEG);
            printf("PRVNI okno %s prstupn.\n",minfo -> WIN_ATR.AWINDOW_ACCES_ENABLED ? "JE" : "NENI");
            printf("Cten obrazov pameti via PRVNI okno %s mozn.\n",minfo -> WIN_ATR.AREAD_ENABLED ? "JE" : "NENI");
            printf("Zpis do obrazov pameti via PRVNI okno %s mozny.\n",minfo -> WIN_ATR.AWRITE_ENABLED ? "JE" : "NENI");
            printf("\nSegmentov adresa DRUHHO okna = %x. ",minfo -> WINB_SEG);
            printf("DRUH okno %s prstupn.\n",minfo -> WIN_ATR.BWINDOW_ACCES_ENABLED ? "JE" : "NENI");
            printf("Cten obrazov pameti via DRUH okno %s mozn.\n",minfo -> WIN_ATR.BREAD_ENABLED ? "JE" : "NENI");
            printf("Zpis do obrazov pameti via DRUH okno %s mozny.\n",minfo -> WIN_ATR.BWRITE_ENABLED ? "JE" : "NENI");

            if (minfo ->MODE_FLAG.NEPOVINNE)
               { char *endstr;
                 printf("===============================================================================\n");
                 printf("X rozlisen je %u bodu. ",minfo -> XRES);
                 printf("Y rozlisen je %u bodu.\n",minfo -> YRES);
                 printf("Srka(X) znakov matice je %u bodu. ",minfo -> XCHRSIZE);
                 printf("Vyska(Y) znakov matice je %u bodu.\n",minfo -> YCHRSIZE);
                 printf("Bitovych rovin je %u. ",minfo -> BIT_PLANES_NUM);
                 printf("Na 1 bod pripad %u bitu.\n",minfo -> BITS_PER_PIXEL);
                 printf("Pametovch bank je %u. ",minfo -> BANKS_NUM);
                 printf("Velikost jedn banky je %u KB.\n",minfo -> BANK_SIZE);

                 switch(minfo -> MEMORY_MODEL)
                    { case 0 : endstr="textovmu rezimu";break;
                      case 1 : endstr="CGA formtu";break;
                      case 2 : endstr="Hercules formtu";break;
                      case 3 : endstr="EGA/VGA 16 formtu";break;
                      case 4 : endstr="zhustenmu formtu 2 body/byte";break;
                      case 5 : endstr="EGA/VGA 256 formtu";break;
                      default: endstr="nektermu novejsmu formtu";
                    };
                 printf("Organizace a struktura obrazov pameti odpovd %s.\n",endstr);
                 printf("\n*******************************************************************************");
               };
         }
         else { chyba();return 0; };
      getch();
   };

void Info(byte sel)
{ /***************************VESA 1.0+ nutnost********************************/
    clrscr();
    switch( sel )
    {
      case  255 : show_vesa_info();
                break;
      default : show_mode_info( SVGAmode[sel].VESAmode );
    }
}