#include "vesa100.h"

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

#define CRTC 0x3D4

#define H_TOTAL 0
#define H_DISP_ENABLE_END 1
#define H_BLANK_START 2
#define H_BLANK_END 3
#define H_RETR_START 4
#define H_RETR_END 5
#define V_TOTAL 6
#define CRTC_OVERFLOW 7
#define PRESET_ROW_SCAN 8
#define MAX_SCAN_LINE 9
#define V_RETR_START 0x10
#define V_RETR_END 0x11
#define V_DISP_ENABLE_END 0x12
#define V_BLANK_START 0x15
#define V_BLANK_END 0x16
#define CRT_MODE_CNTL 0x17

// Atributovy kontroler
#define ATTRIBUTE 0x3c0
#define OVERSCAN_COLOR 0x11
#define H_PEL_PAN 0x13

// Keyboard
#define ESC   0x1b
#define UP    0x48
#define DOWN  0x50
#define LEFT  0x4b
#define RIGHT 0x4d
#define ALT   8
#define SHIFT 3

#define ReadCRTReg(REG) (outp(CRTC,(REG)),inp(CRTC+1))
#define WriteCRTReg(REG,VAL) (outp(CRTC,(REG)),outp(CRTC+1,(VAL)))
#define ChangeCRTReg(REG,VAL) ( WriteCRTReg( (REG),ReadCRTReg(REG)+(VAL) ) )

#define DeadKeyPressed(KEY) ( peekb( 0x40,0x17 ) & KEY )

void main(void)
  {
    printf("\n\nZadej cislo rezimu (hexadecimalne) : ");
    word mod ; scanf("%x",&mod) ;

    byte currmode = peekb(0x40,0x49);

    if (mod > 0x100)
       set_VESA_mode(mod) ;
    else
    { _AX=mod;
      geninterrupt(VIDEO_INT);
    }

    byte i=0;
    while(getch() != ESC)
	{
	  select_access_window(0,i);
	  for(word count=0;count<=0xfffe;count++)
	      pokeb(0xa000,count,0x33);
	  i++;
	};

    byte hrsold = ReadCRTReg(H_RETR_START);
    byte vrsold = ReadCRTReg(V_RETR_START);
    byte hdispenendold = ReadCRTReg(H_DISP_ENABLE_END);
    byte vdispenendold = ReadCRTReg(V_DISP_ENABLE_END);
    byte htotal = ReadCRTReg(H_TOTAL);
//    word vtotal = ReadCRTReg(V_TOTAL);
    byte hblanksold = ReadCRTReg(H_BLANK_START);
    byte vblanksold   = ReadCRTReg(V_BLANK_START);

    WriteCRTReg(V_RETR_END,ReadCRTReg(V_RETR_END) & 0x7f);

    char key;
    while(  ( key = getch() ) != ESC  )
     if ( !key )
	 switch( getch() )
	 {
	     case LEFT :
		  if( !DeadKeyPressed(SHIFT) )
		    ChangeCRTReg( H_RETR_START , 1 );
		  else
		  {
		    ChangeCRTReg( H_DISP_ENABLE_END , -1 );
		    byte hbs ;
		    if( ( hbs = ReadCRTReg(H_BLANK_START) ) > hblanksold )
		      WriteCRTReg( H_BLANK_START , hbs - 1 );
		   }
		  break;

	     case RIGHT :
		  if( !DeadKeyPressed(SHIFT) )
		    ChangeCRTReg( H_RETR_START , -1 );
		  else
		  {
		    byte hdee ,hbs ;
		    if( (  hdee = ReadCRTReg(H_DISP_ENABLE_END) ) <  htotal  )
		    {
		       if(  hdee  >=  ( hbs = ReadCRTReg(H_BLANK_START) )  )
			 WriteCRTReg( H_BLANK_START , hbs + 1 );
		       WriteCRTReg( H_DISP_ENABLE_END , hdee + 1 );
		    } // 1st if
		  }
		  break;

	     case DOWN :
		  if( !DeadKeyPressed(SHIFT) )
		    ChangeCRTReg( V_RETR_START , -1 );
		  else
		  {
		    byte vdee ,vbs ;
		    if( ( vdee = ReadCRTReg(V_DISP_ENABLE_END) )  >=  ( vbs = ReadCRTReg(V_BLANK_START) )  )
			 WriteCRTReg( V_BLANK_START , vbs + 1 );
		    WriteCRTReg( V_DISP_ENABLE_END , vdee + 1 );
		  }
		  break;

	     case UP :
		  if( !DeadKeyPressed(SHIFT) )
		    ChangeCRTReg( V_RETR_START , 1 );
		  else
		  {
		    ChangeCRTReg( V_DISP_ENABLE_END , -1 );
		    byte vbs ;
		    if( ( vbs = ReadCRTReg(V_BLANK_START) ) > vblanksold )
		      WriteCRTReg( V_BLANK_START , vbs - 1 );
		  }
	 };  // switch

     byte hrsnew = ReadCRTReg( H_RETR_START ) ;
     byte vrsnew = ReadCRTReg( V_RETR_START ) ;
     byte hdispenendnew = ReadCRTReg( H_DISP_ENABLE_END );
     byte vdispenendnew = ReadCRTReg( V_DISP_ENABLE_END );
     byte hblanksnew = ReadCRTReg( H_BLANK_START );
     byte vblanksnew = ReadCRTReg( V_BLANK_START );


     WriteCRTReg( V_RETR_END , ReadCRTReg(V_RETR_END) | 0x80 ) ;

     byte bmode  = peekb(0,0x449);

    _AX=currmode;geninterrupt(VIDEO_INT);

    printf("Hodnoty CRT registru pro mod %x <BIOS number %x> jsou tyto :\n",mod,bmode);
    printf("Registr Horizontal Retrace Start : Stara hodnota=%x , Nova hodnota=%x\n",hrsold,hrsnew);
    printf("Registr Vertical   Retrace Start : Stara hodnota=%x , Nova hodnota=%x\n",vrsold,vrsnew);
    printf("Registr Horiz. Disp. Enable End  : Stara hodnota=%x , Nova hodnota=%x\n",hdispenendold,hdispenendnew);
    printf("Registr Vert. Disp. Enable End   : Stara hodnota=%x , Nova hodnota=%x\n",vdispenendold,vdispenendnew);
    printf("Registr Start Horizon. Blanking  : Stara hodnota=%x , Nova hodnota=%x\n",hblanksold,hblanksnew);
    printf("Registr Start Vertical Blanking  : Stara hodnota=%x , Nova hodnota=%x\n",vblanksold,vblanksnew);
    printf("Registr Horizontal Total	     : %x\n",htotal);
    // printf("Registr Vertical   Total 	: %x\n",vtotal);

  }
