#include "vesa100.h"

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

#define CRTC 0x3D4

#define H_TOTAL 0
#define H_DISP_ENABLE_END 1
#define H_BLANK_START 2
#define H_BLANK_END 3
#define H_RETR_START 4
#define H_RETR_END 5
#define V_TOTAL 6
#define CRTC_OVERFLOW 7
#define PRESET_ROW_SCAN 8
#define MAX_SCAN_LINE 9
#define V_RETR_START 0x10
#define V_RETR_END 0x11
#define V_DISP_ENABLE_END 0x12
#define V_BLANK_START 0x15
#define V_BLANK_END 0x16
#define CRT_MODE_CNTL 0x17

// Atributovy kontroler
#define ATTRIBUTE 0x3c0
#define OVERSCAN_COLOR 0x11
#define H_PEL_PAN 0x13

// Keyboard
#define ESC   0x1b
#define UP    0x48
#define DOWN  0x50
#define LEFT  0x4b
#define RIGHT 0x4d
#define ALT   8
#define SHIFT 3

#define ReadCRTReg(REG) (outp(CRTC,(REG)),inp(CRTC+1))
#define WriteCRTReg(REG,VAL) ( outp(CRTC,(REG)) , outp(CRTC+1,(VAL)) )
#define ChangeCRTReg(REG,VAL) ( WriteCRTReg( (REG),ReadCRTReg(REG)+(VAL) ) )

#define ReadCRTRegVRS(VAR) ( (VAR) = ReadCRTReg(V_RETR_START) + ((overflow & 4) << 6) + ((overflow & 0x80) << 2) )
#define ReadCRTRegVBS(VAR) ( (VAR) = ReadCRTReg(V_BLANK_START) + ((overflow & 8) << 5) + ((maxscanline & 0x20) << 4) )
#define ReadCRTRegVDEE(VAR) ( (VAR) = ReadCRTReg(V_DISP_ENABLE_END) + ((overflow & 2) << 7) + ((overflow & 0x40) << 3) )
//#define WriteCRTRegVRS(VAL)  ( WriteCRTReg(V_RETR_START,(VAL)) , WriteCRTReg( CRTC_OVERFLOW, (( (VAL) & 0x200 ) >> 2) ) , WriteCRTReg( CRTC_OVERFLOW, ( ( (VAL) & 0x100 ) >> 6) ) )
//#define WriteCRTRegVBS(VAL)  ( WriteCRTReg(V_BLANK_START,(VAL)) , WriteCRTReg( MAX_SCAN_LINE, (( (VAL) & 0x200 ) >> 4) ) , WriteCRTReg( CRTC_OVERFLOW, ( ( (VAL) & 0x100 ) >> 5) ) )
//#define WriteCRTRegVDEE(VAL) ( WriteCRTReg(V_DISP_ENABLE_END,(VAL)) , WriteCRTReg( CRTC_OVERFLOW , (( (VAL) & 0x200 ) >> 3) ) , WriteCRTReg( CRTC_OVERFLOW, ( ( (VAL) & 0x100 ) >> 7) ) )
//#define ChangeCRTRegVRS(VAL) ( WriteCRTRegVRS(ReadCRTRegVRS(pomoc)+(VAL)) )
//#define ChangeCRTRegVDEE(VAL) ( WriteCRTRegVDEE(ReadCRTRegVDEE(pomoc)+(VAL)) )
//word pomoc;

#define DeadKeyPressed(KEY) ( peekb( 0x40,0x17 ) & KEY )

byte overflow , maxscanline;

void  ChangeCRTRegSpec(byte Registr, signed char value)
{
    word hodnota  = ReadCRTReg(Registr);
    hodnota	 += value;
    overflow	  = ReadCRTReg(CRTC_OVERFLOW);
    maxscanline   = ReadCRTReg(MAX_SCAN_LINE);

    switch(Registr)
    {
      case V_RETR_START :
	   hodnota += ((overflow & 4) << 6) + ((overflow & 0x80) << 2) ;
	   WriteCRTReg(Registr,hodnota);
	   WriteCRTReg( CRTC_OVERFLOW,
		      ( (overflow & 0x7b) |
			( (hodnota & 0x200 ) >> 2 )+
			( (hodnota & 0x100 ) >> 6 ) ) );
	   break;

      case V_BLANK_START :
	   hodnota += ((overflow & 8) << 5) + ((maxscanline & 0x20) << 4) ;
	   WriteCRTReg(Registr,hodnota);
	   WriteCRTReg( MAX_SCAN_LINE,
		       (maxscanline & 0xdf) | ( (hodnota & 0x200 ) >> 4 ) ) ;
	   WriteCRTReg( CRTC_OVERFLOW,
		       (overflow & 0xf7) | ( (hodnota & 0x100 ) >> 5 ) ) ;
	   break;

      case V_DISP_ENABLE_END :
	   hodnota += ((overflow & 2) << 7) + ((overflow & 0x40) << 3) ;
	   WriteCRTReg(Registr,hodnota);
	   WriteCRTReg( CRTC_OVERFLOW,
			(overflow & 0xbd) | ( (hodnota & 0x200 ) >> 3 )+
			( (hodnota & 0x100 ) >> 7 ) ) ;
   }
}

void main(void)
{
    printf("\n\nZadej cislo rezimu (hexadecimalne) : ");
    word mod ; scanf("%x",&mod) ;

    byte currmode = peekb(0x40,0x49);

    if (mod > 0x100)
       set_VESA_mode(mod) ;
    else
    { _AX=mod;
      geninterrupt(VIDEO_INT);
    }

    // Zapln screen a press ESC
    byte i=0;
    while(getch() != ESC)
	{
	  select_access_window(0,i);
	  for(word count=0;count<=0xfffe;count++)
	      pokeb(0xa000,count,0x33);
	  i++;
	};

	 overflow      = ReadCRTReg(CRTC_OVERFLOW);
	 maxscanline   = ReadCRTReg(MAX_SCAN_LINE);
    byte hrsold        = ReadCRTReg(H_RETR_START);
    word vrsold ;	 ReadCRTRegVRS(vrsold);
    byte hdispenendold = ReadCRTReg(H_DISP_ENABLE_END);
    word vdispenendold ; ReadCRTRegVDEE(vdispenendold);
    byte htotal        = ReadCRTReg(H_TOTAL);
    word vtotal        = ReadCRTReg(V_TOTAL) + ((overflow & 1) << 8) + ((overflow & 0x20) << 4);
    byte hblanksold    = ReadCRTReg(H_BLANK_START);
    word vblanksold ;	 ReadCRTRegVBS(vblanksold);

    if(hdispenendold > htotal)
       htotal = 0xff;	 // dokud neznam 9 bit HTOTAL musi byt toto opatreni

    // Break register 0 - 7 protection
    WriteCRTReg(V_RETR_END,ReadCRTReg(V_RETR_END) & 0x7f);

    char key;
    while(  ( key = getch() ) != ESC  )
     if ( !key )
	 switch( getch() )
	 {
	     case LEFT :
		  if( !DeadKeyPressed(SHIFT) )
		    ChangeCRTReg( H_RETR_START , 1 );
		  else
		  {
		    ChangeCRTReg( H_DISP_ENABLE_END , -1 );
		    byte hbs ;
		    if( ( hbs = ReadCRTReg(H_BLANK_START) ) > hblanksold )
		      WriteCRTReg( H_BLANK_START , hbs - 1 );
		   }
		  break;

	     case RIGHT :
		  if( !DeadKeyPressed(SHIFT) )
		    ChangeCRTReg( H_RETR_START , -1 );
		  else
		  {
		    byte hdee ,hbs ;
		    if( (  hdee = ReadCRTReg(H_DISP_ENABLE_END) ) <  htotal  )
		    {
		       if(  hdee  >=  ( hbs = ReadCRTReg(H_BLANK_START) )  )
			 WriteCRTReg( H_BLANK_START , hbs + 1 );
		       WriteCRTReg( H_DISP_ENABLE_END , hdee + 1 );
		    }; // 1st if
		  }
		  break;

	     case DOWN :
		  if( !DeadKeyPressed(SHIFT) )
		    // ChangeCRTReg( V_RETR_START , -1 );
		    ChangeCRTRegSpec(V_RETR_START , -1 );
		  else
		  {
		    word vdee ,vbs ;
		    if( ReadCRTRegVDEE(vdee) < vtotal )
		    {
		       if( vdee   >=   ReadCRTRegVBS(vbs)  )
			 // WriteCRTReg( V_BLANK_START , vbs + 1 );
			 ChangeCRTRegSpec(V_BLANK_START, 1 );
		       // WriteCRTReg( V_DISP_ENABLE_END , vdee + 1 );
		       ChangeCRTRegSpec(V_DISP_ENABLE_END, 1 );
		    } // 1st if
		  }
		  break;

	     case UP :
		  if( !DeadKeyPressed(SHIFT) )
		    //ChangeCRTReg( V_RETR_START , 1 );
		    ChangeCRTRegSpec(V_RETR_START, 1 );
		  else
		  {
		    ChangeCRTRegSpec(V_DISP_ENABLE_END, -1 );
		    word vbs ;
		    if( ReadCRTRegVBS(vbs) > vblanksold )
		      ChangeCRTRegSpec(V_BLANK_START, - 1 );
		  }
	 };  // switch

     byte hrsnew	= ReadCRTReg( H_RETR_START ) ;
     word vrsnew ;	  ReadCRTRegVRS(vrsnew) ;
     byte hdispenendnew = ReadCRTReg( H_DISP_ENABLE_END );
     word vdispenendnew ; ReadCRTRegVDEE(vdispenendnew);
     byte hblanksnew	= ReadCRTReg( H_BLANK_START );
     word vblanksnew ;	  ReadCRTRegVBS(vblanksnew);
     byte overflownew	   = ReadCRTReg(CRTC_OVERFLOW);
     byte maxscanlinenew   = ReadCRTReg(MAX_SCAN_LINE);
     // Protection ON
     WriteCRTReg( V_RETR_END , ReadCRTReg(V_RETR_END) | 0x80 ) ;

     byte bmode  = peekb(0,0x449);

    _AX=currmode;geninterrupt(VIDEO_INT);

    printf("Hodnoty CRT registru pro mod %x <BIOS number %x> jsou tyto :\n",mod,bmode);
    printf("Registr Horizontal Retrace Start : Stara hodnota=%3x , Nova hodnota=%3x\n",hrsold,hrsnew);
    printf("Registr Vertical   Retrace Start : Stara hodnota=%3x , Nova hodnota=%3x\n",vrsold,vrsnew);
    printf("Registr Horiz. Disp. Enable End  : Stara hodnota=%3x , Nova hodnota=%3x\n",hdispenendold,hdispenendnew);
    printf("Registr Vert. Disp. Enable End   : Stara hodnota=%3x , Nova hodnota=%3x\n",vdispenendold,vdispenendnew);
    printf("Registr Start Horizon. Blanking  : Stara hodnota=%3x , Nova hodnota=%3x\n",hblanksold,hblanksnew);
    printf("Registr Start Vertical Blanking  : Stara hodnota=%3x , Nova hodnota=%3x\n",vblanksold,vblanksnew);
    printf("Registr Horizontal Total         : %3x\n",htotal);
    printf("Registr Vertical   Total         : %3x\n",vtotal);
    printf("Registr CRTC Overflow            : Stara hodnota=%3x , Nova hodnota=%3x\n",overflow,overflownew);
    printf("Registr Maximum Scan Line        : Stara hodnota=%3x , Nova hodnota=%3x\n",maxscanline,maxscanlinenew);
}
