Title Using of DPMI Privilegovany kod na CPL=0
.model tiny
.386p

;Ve Windows musi asi byt vsechno locked !!
.code
.startup
mov ax,1687h
int 2fh        ; je DPMI ?
or ax,ax
mov eax,'NotP'
jne DPMIErr

;far skok do DPMI
mov word ptr DPMIService,di
mov word ptr DPMIService+2,es

mov ax,ds:2
sub ax,si
mov es,ax
clc
xor eax,eax	 ; 16. bitove
call DPMIService

mov eax,'Init'	;Chyba pri Init
jc DPMIErr

push ds
pop es

sldt LDTR
sgdt GDTR
sidt IDTR

call DoSelector PASCAL,word ptr GDTR,word ptr GDTR+2 \
		       word ptr GDTR+4,word ptr GDTR+5,\
		       0f2h

mov gs,bx	;GDTAlias
mov GDTAlias,bx

mov si,cs
and si,not 11b	;Ring 0
test si,100b	;In LDT ?
je DoGDT0
and si,not 111b
mov di,LDTR
and di,not 111b
mov cx,gs:[di]	;LDT
mov LDTLim,cx
call DoSelector PASCAL,cx,word ptr gs:[di+2] \
		       word ptr gs:[di+4]  word ptr gs:[di+7] ,0f2h

mov LDTAlias,bx

DoGDT0:
mov fs,bx

;CODE CPL=0
call DoSelector PASCAL,word ptr fs:[si],word ptr fs:[si+2] \
		       word ptr fs:[si+4] word ptr fs:[si+7], \
		       0fah
and bl,not 11b
mov Ring0Code,bx
and bl,not 111b
and byte ptr fs:[bx+5],not 01100000b ;DPL=0

mov si,ds
and si,not 11b
test si,100b
;je DoGDT1
and si,not 111b

;DATA CPL=0
call DoSelector PASCAL,word ptr fs:[si],word ptr fs:[si+2] \
		       word ptr fs:[si+4] word ptr fs:[si+7], \
		       0f2h
mov Ring0Data,bx
and bl,not 11b
mov word ptr Patch1,bx
and bl,not 111b
and byte ptr fs:[bx+5],not 01100000b ;DPL=0

;GATE
call DoSelector PASCAL,offset ProtPart,Ring0Code 0 0 ,0f2h

mov word ptr Gate+2,bx
and bl,not 111b
mov byte ptr fs:[bx+5],0e4h  ;286 Gate kvuli RETF

call Gate

mov si,Ring0Code
and si,not 111b
or byte ptr fs:[si+5],01100000b  ;udelej DPL=3
mov si,Ring0Data
and si,not 111b
or byte ptr fs:[si+5],01100000b  ;udelej DPL=3

mov dx,-1

mov ax,1
mov bx,GDTAlias
int 31h
mov eax,'0001'
jc DPMIErr

mov bx,Ring0Data    ;Nelze uvolnit  DPL<3
mov ax,1
int 31h
mov eax,'0001'
jc DPMIErr

mov bx,Ring0Code    ;Lze uvolnit RPL<3
;or bx,111b
mov ax,1
int 31h
mov eax,'0001'
jc DPMIErr

mov bx,word ptr Gate+2
mov ax,1
int 31h
mov eax,'0001'
jc DPMIErr

mov bx,LDTAlias
cmp bx,0
je NoLDT
mov ax,1
int 31h
mov eax,'0001'
jc DPMIErr

NoLDT:
;DoGDT:
;BeEndung:

call DWordToStringHex PASCAL,RCR0,offset VCR0
call DWordToStringHex PASCAL,RCR2,offset VCR2
call DWordToStringHex PASCAL,RCR3,offset VCR3
call DWordToStringHex PASCAL,RCR4,offset VCR4

call HWrite PASCAL,offset Vypis,0
mov ax,0e07h
int 10h
mov al,-1

DPMIErr:
cmp al,-1
je Ok23
mov ChybaNum,eax
call HWrite PASCAL,offset Chyba,0

Ok23:
.exit

ProtPart:
 push ds
 push eax
 push ecx
 push edx
 push ebx
 Patch1 equ $+1
 mov ax,0
 mov ds,ax
 mov ecx,cr0
 mov edx,cr2
 mov ebx,cr3
 db 0fh,20h,0e0h    ; mov eax,cr4, TASM 3.2 jeste nezna CR4
 mov RCR0,ECX
 mov RCR2,EDX
 mov RCR3,EBX
 mov RCR4,EAX
 pop ebx
 pop edx
 pop ecx
 pop eax
 pop ds
 retf

DoSelector PROC PASCAL @@DLimit,@@DBaseLow,@@DBaseMed:byte,@@DBaseHi:byte,@@DType
uses ax,cx,dx,di
local @@MyDescriptor:byte:8

mov ax,0
mov cx,1
int 31h
mov bx,ax
mov eax,'0000'
jc DPMIErr

mov cx,@@DLimit
mov dx,@@DBaseLow
mov al,@@DBaseMed
mov ah,@@DBaseHi
mov word ptr @@MyDescriptor,cx	    ;Limit
mov word ptr @@MyDescriptor+2,dx  ;Base Low
mov byte ptr @@MyDescriptor+4,al    ;Base High
mov byte ptr @@MyDescriptor+7,ah    ;Base High
mov cx,@@DType	;AR Gate Neprojde
mov word ptr @@MyDescriptor+5,cx  ;AR Gate Neprojde

lea di,@@MyDescriptor
mov ax,0ch
int 31h
mov eax,'000C'
jc DPMIErr
comment /
mov ax,4     ;reserved - lock selector
int 31h
mov eax,'0004'
jc DPMIErr
/
ret
ENDP

DWordToStringHex PROC PASCAL Value:dword,StrPtr:near ptr	;pocet cislic ,cislo v edx
	USES DI,CX,AX,EDX
	pushf
	std
	mov di,StrPtr
	mov cx,8
	dec di
	mov edx,Value
	add di,cx
  @@Cykl:
	mov al,dl
	and al,0Fh
	cmp al,9
	jbe @@Num
	add al,'A'-10 -'0'
    @@Num:
	add al,'0'
    @@Next:
	stosb
	shr edx,4
	dec cx
	jne @@Cykl
  @@Konec:popf
	RET
DWordToStringHex   ENDP

HWrite PROC PASCAL TOfs,Marker:byte
mov si,TOfs
Nachste:
lodsb
cmp al,Marker
je Ob1
mov ah,0eh
int 10h
jmp Nachste
Ob1:
ret
endp

.data
DPMIService dd ?
RawMode dd -1
Ring0Code dw ?
Ring0Data dw ?
Gate dd ?
GDTAlias dw ?
LDTAlias dw 0
LDTLim dw ?
GDTR dp -1
IDTR dp -1
LDTR dw -1

RCR0 dd ?
RCR2 dd ?
RCR3 dd ?
RCR4 dd ?

Vypis db 13,10,'CRi registry via DPMI',13,10
      db 'CR0 :'
VCR0  db '00000000',13,10
      db 'CR2 :'
VCR2  db '00000000',13,10
      db 'CR3 :'
VCR3  db '00000000',13,10
      db 'CR4 :'
VCR4  db '00000000',13,10,0
Chyba db 13,10,7,'Chyba :'
ChybaNum dd 0
	 db 13,10,0
end