Title Presmerovani IRQs

STARTVECTOR equ 50h

.model tiny
.486p

.code
.startup
jmp Install

New08h:
     enter 0,0
     pushf
     cmp cs:IRQActive,0
     jne Go8
;     inc cs:IRQActive
     cmp cs:Nedelej,Yes
     je Go8
     cmp cs:Delej,Yes
     jne Go8
     ; cmp Any INt and DOSBusy
     cmp word ptr [bp+4],1234h	;patchuj
     LowCS equ $-2
     jb Go8
     cmp word ptr [bp+4],0a000h
     jae Go8

     push ds ax bx cx si di es fs

     mov si,[bp+2] ;IP
     mov ds,[bp+4] ;CS

     ; Get PSP
;     mov ah,51h
;     int 21h
     mov bx,word ptr cs:LowCS
    HledejPSP:
     inc bx
     mov fs,bx
     cmp word ptr fs:0,20cdh
     jne HledejPSP
     ;zavri files

     ;kbd
;     mov [si],60e6ffb0h   ; mov al,0ffh  out 60h,al
     mov [si],90909090h   ; mov al,0ffh  out 60h,al
     ; screen
     mov [si+4],0cd0003b8h  ; mov ax,0003h int
     mov byte ptr [si+4+4],10h	     ; 10h

     ; memory	v bx a fs je PSP
     dec bx
     mov es,bx	  ; MCB
;    inc bx	  ; ?
     cmp byte ptr es:0,'M'
     jne NoPatchMCB
;     cmp byte es:0,'Z'
;     je NoPatch
     mov byte ptr es:0,'Z'
     mov ax,fs:2
     sub ax,bx
     mov word ptr es:3,ax

   NoPatchMCB:
     ; exit
     mov [si+5+4],0cd4c00b8h  ; mov ax,4c00h int
     mov byte ptr [si+4+5+4],21h       ; 21h

     push cs
     pop ds
     lea si,SaveIntTable
     xor di,di
     mov cx,256
     mov es,di
     cld
     rep movsd

     mov cs:Nedelej,Yes
     mov al,36h
     out 43h,al
     jcxz $+2
     mov al,0
     out 40h,al
     jcxz $+2
     out 40h,al
     mov al,20h
     out 20h,al
     pop fs es di si cx bx ax ds
     popf
     leave
;     dec cs:IRQActive
     iret
   Go8:
     popf
     leave
  ;   inc cs:IRQActive
     int 8
  ;   dec cs:IRQActive
     iret

   Delej db 0
   Nedelej db 0
   IRQActive db 0

New09h:
 Yes equ 1
     pushf
     inc cs:IRQActive
     push ax
     in al,60h
     cmp al,81h  ;ESC Exits UP
     pop ax
     jne Go9
     mov cs:Delej,Yes
    NoAct:
     push ax
     in al,61h
     mov ah,al
     or al,80h
     out 61h,al
     mov al,ah
     out 61h,al
     mov al,20h
     out 20h,al
     pop ax
     popf
     dec cs:IRQActive
     mov cs:Delej,Yes
     iret
   Go9:
     popf
     int 9
     dec cs:IRQActive
     iret
New0ah:
     inc cs:IRQActive  ;spravne pushf a popf
     int 10
     dec cs:IRQActive
     iret
New0bh:
     inc cs:IRQActive
     int 11
     dec cs:IRQActive
     iret
New0ch:
     inc cs:IRQActive
     int 12
     dec cs:IRQActive
     iret
New0dh:
     inc cs:IRQActive
     int 13
     dec cs:IRQActive
     iret
New0eh:
     inc cs:IRQActive
     int 14
     dec cs:IRQActive
     iret
New0fh:
     inc cs:IRQActive
     int 15
     dec cs:IRQActive
     iret


IntTable1 dw offset New08h,offset New09h,offset New0ah,offset New0bh
	  dw offset New0ch,offset New0dh,offset New0eh,offset New0fh
ILength  equ ($ - IntTable1) / 2


Install:
lea bx,IntTable1
xor ah,ah
mov al,STARTVECTOR
mov cx,ILength

SetVec:
push ax
mov dx,[bx]
mov ah,25h
int 21h
pop ax
inc ax
inc bx
inc bx
loop SetVec

lea di,SaveIntTable
xor si,si
mov cx,256
mov ds,si
cli
cld
rep movsd
sti
push es
pop ds

mov ah,9
lea dx,War1
int 21h
mov ah,0
int 16h
      cli
      in al,21h
      mov ah,al
      mov al,11h
      out 20h,al
     jmp @1
  @1:
      mov al,STARTVECTOR
      out 21h,al
      jmp @2
   @2:
      mov al,4
      out 21h,al
      jmp @3
    @3:
      mov al,1
      out 21h,al
      jmp @4
    @4:
      mov cx,-1
    @5:
      loop @5
      mov al,ah
      out 21h,al   ;nebo 0ffh
      sti

    lea bx,EndProg
    add bx,15
    shr bx,4
    mov word ptr LowCS,es
    add word ptr LowCS,bx
    mov ah,4ah
    int 21h
    mov sp,100h


    lea dx,GName
    lea bx,Execute
    mov [bx].CmdSeg,ds
    mov [bx].FCB1Seg,ds
    mov [bx].FCB2Seg,ds
    mov ax,4b00h
    int 21h

   ;odinstaluj IRQ
      cli
      in al,21h
      mov ah,al
      mov al,11h
      out 20h,al
     jmp @@1
   @@1:
      mov al,8	  ;STARTVECTOR
      out 21h,al
      jmp @@2
   @@2:
      mov al,4
      out 21h,al
      jmp @@3
    @@3:
      mov al,1
      out 21h,al
      jmp @@4
    @@4:
      mov cx,-1
    @@5:
      loop @@5
      mov al,ah
      out 21h,al   ;nebo 0ffh
      sti
   ;vrat vectory
   mov ax,305h
   xor bx,bx
   int 16h
   lea dx,War2
   mov ah,9
   int 21h
   mov ah,0
   int 16h

   .exit 0

.data
ExecParameters STRUC
   Environment dw 0
   CmdLine   dw 80h
   CmdSeg    dw 0
   FirstFCB  dw 80h
   FCB1Seg   dw 0
   SecondFCB dw 80h
   FCB2Seg   dw 0
ENDS
 Execute ExecParameters <>;<?,offset OneCMD,?,?,?,?,?>
 GName db 'mach3.exe',0
 War1 db 13,10,'ESC ukon nsledujc program ! ',13,10,'Press any key ..',36
 War2 db 13,10,'Systm je nyn v polostabilnm stavu !',13,10,'Pokud chce vn '
      db       'pracovat, radji resetuj Ctrl+Alt+Del.',13,10
      db       'Press any key..',36

 SaveIntTable dd 256 dup (?)
 EndProg label
end