Title Prehazovac klavesnic
;Presmerovani IRQs posli Break do Turbo Debuggeru
;' save vec 1,3,9,disable irq 0
;Scroll Lock restores vec 1,3,9,enable irq 0
;Problem TD's obsluha int 1 a int 3 enabluji irq 0 !

STARTVECTOR equ 50h

.model tiny
.486p

.code
.startup
jmp Install

KBD_End PROC PASCAL
uses ax
     in al,61h
     mov ah,al
     or al,80h
     out 61h,al
     mov al,ah
     out 61h,al
    ;EOI
     mov al,20h
     out 20h,al
     ret
KBD_End ENDP

Recorded db 0
WasSaved db 0
LastInt08 dd ?
LastInt09 dd ?
TDInt03 dd ?
TDInt01 dd ?
NowInt8 dd ?
NowInt9 dd ?
NowInt3 dd ?
NowInt1 dd ?
New08h:
     cmp cs:Recorded,111b
     je Quit8
     push ds
     push 0
     pop ds
     push ax ebx
     mov al,cs:Recorded
     test al,001b    ;to bude treba INT 9
     jne A8
     mov ebx,ds:9*4
     cmp ebx,cs:LastInt09
     je A8
     mov cs:TDInt09,ebx
     or al,001b
    A8:
     test al,010b    ;to bude treba INT 3
     jne B8
     mov ebx,ds:3*4
     cmp ebx,cs:TDInt03
     je B8
     mov cs:TDInt03,ebx
     or al,010b
    B8:
     test al,100b    ;to bude treba INT 1
     jne C8
     mov ebx,ds:1*4
     cmp ebx,cs:TDInt01
     je C8
     mov cs:TDInt01,ebx
     or al,100b
    C8:
     mov cs:Recorded,al
     pop ebx ax ds
    Quit8:
     sti
     int 8
     iret

New09h:
     pushf
     push ax
     in al,60h
     cmp al,29h or 80h ; ignore break code
     je Ignore
     cmp al,46h or 80h ; ignore break code
     je Ignore
     cmp al,46h        ; Scroll Lock ..restore
     je IRQ0On
     cmp al,29h        ; ' ..save & go
     pop ax
     jne Go9
     cmp cs:TDInt09,0
     je Go9
     cmp cs:WasSaved,0
     jne Go9
     push ds 0
     pop ds
     push dword ptr ds:8*4
     pop cs:NowInt8
     push dword ptr ds:9*4
     pop cs:NowInt9
     push dword ptr ds:3*4
     pop cs:NowInt3
     push dword ptr ds:1*4
     pop cs:NowInt1
     call GetUserFreq
     push cs:LastInt08
     pop dword ptr ds:8*4
     push cs:TDInt09
     pop dword ptr ds:9*4
     push cs:TDInt03
     pop dword ptr ds:3*4
     push cs:TDInt01
     pop dword ptr ds:1*4
     pop ds
     mov cs:WasSaved,1
;     push ax
;     in al,21h
;     or al,1
;     out 21h,al
;     pop ax
     popf
     db 0eah;  jmp TDInt09
     TDInt09 dd 0

   IRQ0On:
	  pop ax
	  cmp cs:WasSaved,1
	  jne Go9
	  push ds 0
	  pop ds
	  push cs:NowInt8
	  pop dword ptr ds:8*4
	  push cs:NowInt9
	  pop dword ptr ds:9*4
	  push cs:NowInt3
	  pop dword ptr ds:3*4
	  push cs:NowInt1
	  pop dword ptr ds:1*4
	  pop ds
	  call SetUserFreq
	  popf
	  mov cs:WasSaved,0
	  jmp cs:TDInt09
;	   in al,21h
;	   and al,not 1
;	   out 21h,al
   Ignore:
	  pop ax
   Std_END:
	  call KBD_End
	  popf
	  iret

   Go9:
     popf
     sti
     int 9
     iret

New0ah:
     int 10
     iret
New0bh:
     int 11
     iret
New0ch:
     int 12
     iret
New0dh:
     int 13
     iret
New0eh:
     int 14
     iret
New0fh:
     int 15
     iret

NowFreq dw ?

GetUserFreq PROC PASCAL
uses ax,cx,edx,bx,edi

VelkyCykl:
mov cx,10    ;Z kolika hodnot
xor edx,edx
mov dx,-1
xor edi,edi

Cykl1:
mov bx,-1
Cykl:
mov al,06h
out 43h,al
in al,40h
mov ah,al
in al,40h
xchg ah,al
xchg ax,bx
cmp bx,ax
jb Cykl
dec cx
jle @21
cmp dx,ax
jb Cykl1
cmp di,bx
ja Cykl1
mov dx,ax
mov di,bx
jmp Cykl1

@21:
cmp di,dx
je VelkyCykl
cmp di,0
je VelkyCykl

mov bx,dx
add edx,edi
add edx,edi
shr edx,1
cmp dx,bx
jnb NotMustBeZero

MustBeZero:
xor dx,dx

NotMustBeZero:

mov cs:NowFreq,dx

     mov al,36h
     out 43h,al
     jcxz $+2
     mov al,0
     out 40h,al
     jcxz $+2
     out 40h,al
     ret
GetUserFreq ENDP

SetUserFreq PROC PASCAL
uses ax
     mov al,36h
     out 43h,al
     jcxz $+2
     mov ax,cs:NowFreq
     out 40h,al
     jcxz $+2
     mov al,ah
     out 40h,al
     ret
SetUserFreq ENDP

IntTable1 dw offset New08h,offset New09h,offset New0ah,offset New0bh
	  dw offset New0ch,offset New0dh,offset New0eh,offset New0fh
ILength  equ ($ - IntTable1) / 2


Install:
lea dx,Copy
mov ah,9
int 21h

mov si,80h
mov cl,[si]
xor ch,ch
or cx,cx
je Info
	 inc cx
	 lodsb
	 cld
@Parse1: lodsb
	 cmp al,20h
	 ja @Parse2
	 loop @Parse1
@Parse2: add NameStart,si
@Parse3: lodsb
	 cmp al,20h
	 jna @Parse4
	 loop @Parse3
@Parse4: mov byte ptr [si-1],0
	 add si,40h
	 mov di,si
	 inc di      ;delka
	 inc di      ;mezera
	 std
	 mov cx,41h
	 rep movsb
	 inc si
	 cld
	 mov ParmStart,si
	 push si
      sem: lodsb
	 cmp al,' '
	 jb  Ven
	 jmp sem
	Ven:
	 sub si,ParmStart
	 mov ax,si
	 dec ax
	 pop si
	 mov ah,' '
	 mov word ptr [si],ax

lea di,SaveIntTable
mov si,STARTVECTOR*4
mov cx,ILength
push 0
pop ds
cld
cli
rep movsd
sti

push ds
push es
pop ds
pop es

push cs
push 0
pop eax

lea si,IntTable1
mov di,STARTVECTOR * 4
mov cx,ILength

cli
@SetMyVecs:
 lodsw
 stosd
 loop @SetMyVecs
sti

mov ah,9
lea dx,War1
int 21h

push dword ptr es:8*4
pop LastInt08
push dword ptr es:9*4
pop LastInt09
push dword ptr es:3*4
pop TDInt03
push dword ptr es:1*4
pop TDInt01

    push ds
    pop es
    lea bx,EndProg
    add bx,15
    shr bx,4
    mov ah,4ah
    int 21h
    mov sp,100h

    mov bl,STARTVECTOR
    call SetPIC
    ;oznam VCPI


    mov dx,NameStart
    lea bx,Execute
    push ParmStart
    pop [bx].CmdLine
    mov [bx].CmdSeg,ds
    mov [bx].FCB1Seg,ds
    mov [bx].FCB2Seg,ds
    push ds
    pop es
    mov ax,4b00h
    int 21h
    setc FailureD

lea si,SaveIntTable
mov di,STARTVECTOR*4
mov cx,ILength
push 0
pop es
cld
cli
rep movsd
sti
    mov bl,8
    call SetPIC

   mov ax,305h
   xor bx,bx
   int 16h	   ; rychla KBD
  cmp FailureD,1
  je Fail
   .exit 0

Info:
   mov ah,9
   lea dx ,Inform
   int 21h
   .exit 1
Fail:
   mov ah,9
   lea dx,Failure
   int 21h
   .exit 2

SetPIC PROC PASCAL  ; parametr start vektor pro IRQ0 v BL
      cli
      in al,21h
      mov ah,al
      mov al,11h
      out 20h,al
     jmp @1
  @1:
      mov al,BL
      out 21h,al
      jmp @2
   @2:
      mov al,4
      out 21h,al
      jmp @3
    @3:
      mov al,1
      out 21h,al
      jmp @4
    @4:
      mov cx,-1
    @5:
      loop @5
      mov al,ah
      out 21h,al   ;nebo 0ffh
      sti
      ret
SetPIC ENDP

.data
ExecParameters STRUC
   Environment dw 0
   CmdLine   dw 80h
   CmdSeg    dw 0
   FirstFCB  dw 80h
   FCB1Seg   dw 0
   SecondFCB dw 80h
   FCB2Seg   dw 0
ENDS
 Execute ExecParameters <>
 FailureD db 0
 NameStart dw -1
 ParmStart dw 1
 Copy	db 13,10,'+++ TDKey  by Eli 1997 +++',36
 Inform db 13,10,'syntax: TDKey TDSpec <DebFile>'
	db 13,10,'- spust program TDSpec (td.exe,td286.exe)'
	db 13,10,'- po stisku ` se DebFile prerusi a je mozne debuggovat'
	db 13,10,'- po stisku Scroll Lock se obnovi vektory'
	db 13,10,36
 War1	db 13,10,'Klvesa ` prerusi program ! ',36
 Failure db 13,10,7,'TDKey: Specifikovan program nelze spustit !',36
 SaveIntTable dd ILength dup (?)
 EndProg label
end
